
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE All;
IMPORT IO,graphics,WindowS,Menus,Processs,Str,TextView,MATHLIB,Lib,SYSTEM;
CONST FuSetWinDepth =32;

PROCEDURE WrStrCol(X,Y:SHORTCARD;S:ARRAY OF CHAR;N:SHORTCARD);
VAR R:  SYSTEM.Registers;
    A,B,C,D,E,G,H,I,M:CARDINAL;
BEGIN
      A:=R.AX; B:=R.BX; C:=R.CX; D:=R.DX; E:=R.BP; G:=R.SI; H:=R.DI;
      R.DL:=X; R.DH:=Y; R.BH:=0; R.AH:=2; Lib.Intr(R,010H);
      M:=Str.Length(S);
      FOR I:=0 TO M-1 DO
         R.AH:=0EH;          R.AL:=SHORTCARD(S[I]);
         R.BH:=0;   R.BL:=N; Lib.Intr(R,10H);
     END;
     R.AX:=A; R.BX:=B; R.CX:=C; R.DX:=D; R.BP:=E; R.SI:=G; R.DI:=H;
END WrStrCol;

VAR   WinNf,FuSetWin1 : WindowS.WinType;
CONST FC=Kern.F(FALSE,FALSE,1.E10,1.E10,1.,3,1,Kern.TyStolbX(0.,0.,0.,0.,0.,0.,0.),
           FALSE,Kern.TypnfX(1,1,1,1,1,1,1),1);
PROCEDURE GetF():BOOLEAN;
 VAR Select:BOOLEAN;
 PROCEDURE RdNumFu(): BOOLEAN;
  VAR SpReal  : LONGREAL;
      Yes     : CHAR;
      testFu  : Kern.F;
      Nfu,ii,nfXhelp  : LONGCARD;
      i               : CARDINAL;
  BEGIN
  Yes:=Menus.GetKey();
  CASE Yes OF
    | CHR(13):      (* <Enter> *)
      WindowS.PutOnTop(Menus.Anounse);
      Menus.WrStrAnounse( FALSE,' No. -樨');
      Menus.WrStrAnounse( FALSE,' ');
      Menus.WrStrAnounse( FALSE,' ');
      WindowS.PutOnTop(WinNf); IO.WrLn; IO.WrStr('No.=');
      Nfu:=IO.RdLngCard();
      IF WindowS.Fortuna THEN
        IF (Nfu>10) THEN
           WindowS.Hide(Menus.Anounse); WindowS.Hide(WinNf);
           SpReal:=MATHLIB.Log10(LONGREAL(Nfu));
           testFu:=FC;
           testFu.Sp:=TRUNC(SpReal);
           ii:=1;
           FOR i:=1 TO testFu.Sp DO
              nfXhelp:= Nfu DIV ii;
              testFu.nfX[1+testFu.Sp-i]:=Kern.TypFx(nfXhelp MOD 10);
              ii:=ii*10;
           END;
           testFu.nfY:=Kern.TypFy( Nfu DIV ii);

           Kern.SetUpFu(testFu);  (* !!!!!! *)
           IF NOT testFu.Error THEN  Processs.IniSi := TRUE;
                                     Processs.Si    := testFu
           ELSE                      Processs.IniSi := TRUE
           END;
           Select:=TRUE;
           RETURN TRUE;
         ELSE  (* Nfu <=10 *)
           WindowS.Hide(WinNf);
           WindowS.Hide(Menus.Anounse);
           Select:=FALSE;
           RETURN FALSE
        END
      ELSE  (* not fortuna *)
         WindowS.Hide(Menus.Anounse); WindowS.Hide(WinNf);
         Select:=FALSE;
         RETURN FALSE
      END
    | 'r',CHR(27):       (* <Esc> *)
           Select:=FALSE;
           RETURN TRUE
   ELSE              (* Lubaja *)
           Select:=FALSE;
           RETURN FALSE
   END
 END RdNumFu;

TYPE TyPaletta = ARRAY [1..10] OF CARDINAL;
CONST Paletta  = TyPaletta(15,14,15,14,15,14,15,14,15,14);
VAR Test      : Kern.F;
 PROCEDURE InitSpSmol(NumSp:Kern.TypSp):BOOLEAN;
   VAR marc    : ARRAY [0..11] OF CHAR;
       OK      : BOOLEAN;
       Num,ii  : LONGCARD;
       i       : CARDINAL;
   BEGIN
      Kern.SetUpFu(Test);
      IF NOT Test.Error THEN     ii:=1; Num:=0;
         FOR i:=1 TO NumSp DO
              Num:=Num+ii*LONGCARD(Test.nfX[1+NumSp-i]);
              ii:=ii*10;
         END; Num:=Num+ii*LONGCARD(Test.nfY);
         Str.IntToStr(LONGINT(Num),marc,10,OK);
         IF ((Test.nfY=Kern.Sp[NumSp].nfY)AND(Test.nfX=Kern.Sp[NumSp].nfX))
             OR((Test.nfY=Kern.Sm[NumSp].nfY)AND(Test.nfX=Kern.Sm[NumSp].nfX))
         THEN graphics.setcolor(13);
               graphics.outtextxy(20,TextView.POSwGeneral,marc);
               TextView.POSwGeneral:=TextView.POSwGeneral+9;
               TextView.Wr(Test);graphics.setcolor(Paletta[NumSp])
         ELSE graphics.outtextxy(20,TextView.POSwGeneral,marc);
               TextView.POSwGeneral:=TextView.POSwGeneral+9;
               TextView.Wr(Test);
         END;
      END;
      IF TextView.POSwGeneral>=290 THEN
          WindowS.GotoXY(1,23);
(*IO.WrStr('  <Entr>-enter function of interest,  <Any>-next page of list,  <Esc>-exit');*)
          IO.WrStr('<Entr>- ࠢ襩 -樨,  <>-ᬮ ᯨ᪠,  <Esc>-室');
          IF RdNumFu() THEN RETURN TRUE
          ELSE              TextView.Clear(FuSetWin1,1);
                            RETURN FALSE
          END;
      END;  (* IF Sum *)
      RETURN FALSE
   END InitSpSmol;

CONST FC=Kern.F(FALSE,FALSE,1.E10,1.E10,1.,3,1,Kern.TyStolbX(0.,0.,0.,0.,0.,0.,0.),
                FALSE,Kern.TypnfX(1,1,1,1,1,1,1),1);
 PROCEDURE InitSp(Spisoc:Kern.TypSp):BOOLEAN;
 VAR    nfX1,nfX2,nfX3,nfX4,nfX5,nfX6,nfX7,nfX8     :  Kern.TypFx;
        nfY       : Kern.TypFy;
 BEGIN
    Test:=FC;     Test.Sp:=Spisoc;
    FOR nfY:=1 TO Kern.MaxFuNumYv DO  IF NOT Kern.ErrorFy[nfY]  THEN Test.nfY:=nfY;
     FOR nfX1:=Spisoc TO Kern.MaxFuNumXv DO  IF NOT Kern.ErrorFx[nfX1] THEN Test.nfX[1]:=nfX1;
       IF Spisoc>=2 THEN
          FOR nfX2:=Spisoc-1 TO nfX1-1 DO IF NOT Kern.ErrorFx[nfX2] THEN Test.nfX[2]:=nfX2;
            IF Spisoc>=3 THEN
             FOR nfX3:=Spisoc-2 TO nfX2-1 DO IF NOT Kern.ErrorFx[nfX3] THEN Test.nfX[3]:=nfX3;
              IF Spisoc>=4 THEN
               FOR nfX4:=Spisoc-3 TO nfX3-1 DO IF NOT Kern.ErrorFx[nfX4] THEN Test.nfX[4]:=nfX4;
                 IF Spisoc>=5 THEN
                  FOR nfX5:=Spisoc-4 TO nfX4-1 DO IF NOT Kern.ErrorFx[nfX5] THEN Test.nfX[5]:=nfX5;
                    IF Spisoc>=6 THEN
                     FOR nfX6:=Spisoc-5 TO nfX5-1 DO IF NOT Kern.ErrorFx[nfX6] THEN Test.nfX[6]:=nfX6;
                       IF Spisoc>=7 THEN
                        FOR nfX7:=Spisoc-6 TO nfX6-1 DO IF NOT Kern.ErrorFx[nfX7] THEN Test.nfX[7]:=nfX7;
                          IF Spisoc>=8 THEN
                          ELSE IF InitSpSmol(7) THEN RETURN TRUE END
                          END
                        END END  (* nfX7 *)
                       ELSE IF InitSpSmol(6) THEN RETURN TRUE END
                       END
                     END END  (* nfX6 *)
                    ELSE IF InitSpSmol(5) THEN RETURN TRUE END
                    END
                   END END  (* nfX5 *)
                 ELSE IF InitSpSmol(4) THEN RETURN TRUE END
                 END
                END END  (* nfX4 *)
              ELSE IF InitSpSmol(3) THEN RETURN TRUE END
              END
             END END  (* nfX3 *)
            ELSE IF InitSpSmol(2) THEN RETURN TRUE END
            END
        END END  (* nfX2 *)
     ELSE IF InitSpSmol(1) THEN RETURN TRUE END
     END
     END END  (* nfX1 *)
   END END; (* nfY *)
   RETURN FALSE
END InitSp;

VAR i     : Kern.TypSp;
    k,k1  : CARDINAL;
BEGIN
  TextView.POSwGeneral:=14;
  graphics.settextstyle(2,0,4);
  graphics.setfillstyle(graphics.SOLID_FILL,1);
  WrStrCol(1,17,CHR(179),14+128);
  WrStrCol(78,17,CHR(179),14+128);
  FOR k1:=8 TO 24 DO k:=24-k1;
      graphics.bar(10,14*k,630,14*k+30);
      WrStrCol(2,SHORTCARD(k),CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
            '㥬 㭪樨 '  +CHR(196)+CHR(196)+CHR(196)+CHR(196)+
            CHR(196)+CHR(196)+
            CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
            CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
            CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
            CHR(196)+'..'+CHR(196)+CHR(196)+'.⪫.',
            10+128);
      WrStrCol(1,SHORTCARD(k+1),CHR(179),10+128);
      WrStrCol(78,SHORTCARD(k+1),CHR(179),10+128);
      WrStrCol(1,SHORTCARD(k+2),CHR(179),10+128);
      WrStrCol(78,SHORTCARD(k+2),CHR(179),10+128);
      WrStrCol(1,SHORTCARD(k),CHR(179),10+128);
      WrStrCol(78,SHORTCARD(k),CHR(179),10+128);
  END;
  TextView.PutOnTop(FuSetWin1,1);
  FOR i:=1 TO Kern.MaxFuNumX DO
   graphics.setcolor(Paletta[i]);
   IF InitSp(i) THEN WindowS.Clear();
  FOR k:=0 TO 16 DO
  graphics.setfillstyle(graphics.SOLID_FILL,0);
      graphics.bar(5,14*k,635,14*k+14);
      WrStrCol(2,SHORTCARD(k+1),CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
            '㥬 㭪樨 '  +CHR(196)+CHR(196)+CHR(196)+CHR(196)+
            CHR(196)+CHR(196)+
            CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
            CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
            CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
            CHR(196)+'..'+CHR(196)+CHR(196)+'.⪫.',
            10+128);
  END;
        TextView.PutOnTop(TextView.WinFuDelt,1);
        WindowS.Hide(FuSetWin1);
        RETURN Select;
   END
  END;
  IF RdNumFu() THEN END;
  WindowS.Clear();
  WindowS.Hide(FuSetWin1);
  TextView.PutOnTop(TextView.WinFuDelt,1);
  RETURN Select
END GetF;

PROCEDURE Init;
 BEGIN
 FuSetWin1:= WindowS.Open(
      WindowS.WinDef(1,0,78,24,               WindowS.LightRed, WindowS.White,
      FALSE,TRUE,FALSE,TRUE,WindowS.SingleFrame,WindowS.LightGreen, WindowS.White));
 WindowS.SetTitle( FuSetWin1,
(*    CHR(196)+CHR(196)+'Stand./Max.Residual'+CHR(196)+CHR(196)+CHR(196)+CHR(196)
      + 'Formula',WindowS.LeftUpperTitle);*)
 'No.'+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
      CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
      '㫠'+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
      CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
      CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
      CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
      CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
      '..'+CHR(196)+CHR(196)+'.⪫.',WindowS.LeftUpperTitle);
 WinNf:= WindowS.Open(
      WindowS.WinDef(48,13,70,15,               WindowS.LightGreen, WindowS.Black,
      FALSE,TRUE,TRUE,TRUE,WindowS.SingleFrame,WindowS.Green, WindowS.Black));
(* WindowS.SetTitle( WinNf,'Select formula No.',WindowS.CenterUpperTitle);*)
 WindowS.SetTitle( WinNf,'  No. 㭪樨',WindowS.CenterUpperTitle);
END Init;

END All.
