
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE Collect;
IMPORT Kern,Str,WindowS,graphics,TextView,Menus,MuvMul,File;
FROM MATHLIB IMPORT Sqrt,Log10;

VAR    Len               : LONGREAL;
PROCEDURE Wr(Fu:Kern.F);
VAR R:ARRAY[0..100] OF CHAR;
    D    : LONGREAL;
    marc : ARRAY [0..11] OF CHAR;
    OK   : BOOLEAN;
    i,Class,NewClass    : CARDINAL;
    horPos,WidthD : INTEGER;
BEGIN
IF NOT Fu.Error THEN horPos:=10;
  IF NOT Fu.Co THEN Fu:=Kern.Reform(Fu) END;

  graphics.bar(2,TextView.POSwGeneral+2,638,TextView.POSwGeneral+16);
  graphics.line(2,TextView.POSwGeneral+15,638,TextView.POSwGeneral+15);
  graphics.line(2,TextView.POSwGeneral+17,638,TextView.POSwGeneral+17);

  Str.CardToStr(LONGCARD(Fu.Class),marc,10,OK); IF OK THEN Str.Copy(R,marc) END;
  Str.Append(R,'   ');
  graphics.outtextxy(horPos,TextView.POSwGeneral,R);
  horPos:=graphics.textwidth(R)+horPos;

  Str.Copy(R,Fu.BsY.TxRev1); Str.Append(R,Fu.BsY.TxRev2);
  graphics.setcolor(Fu.BsY.Color); graphics.outtextxy(horPos,TextView.POSwGeneral,R);
  horPos:=graphics.textwidth(R)+horPos;
  FOR i:=1 TO Fu.Sp DO
     IF Fu.M[i]>0. THEN Str.Copy(R,'+')
     ELSE Str.Copy(R,' ')
     END;
     Str.RealToStr(Fu.M[i],3,TRUE,marc,OK); IF OK THEN Str.Append(R,marc) END;
     Str.Append(R,Fu.BsX[i].Tx1); Str.Append(R,Fu.BsX[i].Tx2);Str.Append(R,Fu.BsX[i].Tx3);
     graphics.setcolor(Fu.BsX[i].Color);
     WidthD:=graphics.textwidth(R);
     IF 627-horPos < WidthD THEN TextView.POSwGeneral:=TextView.POSwGeneral+10;
          graphics.bar(2,TextView.POSwGeneral+2,638,TextView.POSwGeneral+16);
          graphics.line(2,TextView.POSwGeneral+15,638,TextView.POSwGeneral+15);
          graphics.line(2,TextView.POSwGeneral+17,638,TextView.POSwGeneral+17);
          horPos:=200
     END;
     graphics.outtextxy(horPos,TextView.POSwGeneral,R);
     horPos:=graphics.textwidth(R)+horPos;
  END; (* for *)

  Str.Copy(R,Fu.BsY.TxRev3);  graphics.settextstyle(2,0,4);
  graphics.setcolor(Fu.BsY.Color); graphics.outtextxy(horPos,TextView.POSwGeneral,R);
  horPos:=graphics.textwidth(R)+horPos;

  D:=Sqrt(Fu.Delta2)/LONGREAL(MuvMul.MaxPointNum);
  IF D>1.E-50 THEN Len:=-Log10(D)
  ELSE Len:=50.
  END;
  Str.RealToStr(D,3,TRUE,marc,OK);IF OK THEN Str.Concat(R,' ',marc) END;
  Str.Append(R,' ');
  Str.RealToStr(Fu.Delta,3,TRUE,marc,OK);IF OK THEN  Str.Append(R,marc) END;
  graphics.setcolor(11);
  WidthD:=graphics.textwidth(R);
  IF    (MuvMul.Aty IN Fu.Mode) OR (MuvMul.Bty IN Fu.Mode)
     OR (MuvMul.Cty IN Fu.Mode) OR (MuvMul.Dty IN Fu.Mode) THEN
   TextView.POSwGeneral:=TextView.POSwGeneral+10;
   graphics.bar(2,TextView.POSwGeneral+2,638,TextView.POSwGeneral+16);
   graphics.line(2,TextView.POSwGeneral+15,638,TextView.POSwGeneral+15);
   graphics.line(2,TextView.POSwGeneral+17,638,TextView.POSwGeneral+17);
   graphics.outtextxy(627-WidthD,TextView.POSwGeneral,R);
  ELSE IF 627-horPos < WidthD THEN TextView.POSwGeneral:=TextView.POSwGeneral+10;
          graphics.bar(2,TextView.POSwGeneral+2,638,TextView.POSwGeneral+16);
          graphics.line(2,TextView.POSwGeneral+15,638,TextView.POSwGeneral+15);
          graphics.line(2,TextView.POSwGeneral+17,638,TextView.POSwGeneral+17);
       END;
       graphics.outtextxy(627-WidthD,TextView.POSwGeneral,R);
       TextView.POSwGeneral:=TextView.POSwGeneral+10;
  END;
 END (* not Error *)
END Wr;

PROCEDURE Frame(col,row : CARDINAL);
BEGIN (*WindowS.PutOnTop(WinRezMin);*)
      graphics.setfillstyle(graphics.SOLID_FILL,1);
         graphics.bar(col,row-1,col+137,row+50);
      graphics.setcolor(3);
         graphics.line(col+2,  row,col+135,row);
         graphics.line(col+2,  row+49,col+135,row+49);
         graphics.line(col+2,(*167*)row,col+2,  row+49);
         graphics.line(col+15, row,col+15, row+49);
         graphics.line(col+45, row,col+45, row+49);
         graphics.line(col+75, row,col+75, row+49);
         graphics.line(col+105,row,col+105,row+49);
         graphics.line(col+135,row,col+135,row+49);
        graphics.settextstyle(2,0,2);
        IF row>150 THEN  graphics.setfillstyle(graphics.SOLID_FILL,0) END;
        graphics.bar(col-1,(*218*)row+50,col+137,(*223*)row+55);
        graphics.outtextxy(col+18,row+51,'0     -1     -2     -3     -4');
        graphics.settextstyle(2,0,4);
END Frame;
PROCEDURE OpenFrame;
 VAR   i : CARDINAL;
       x1,x2,dx,  y1,y2,dy : CARDINAL;
 BEGIN
       dy:=10;
       x1:=491; y1:=182-dy; x2:=629; y2:=217;
       FOR i:=1 TO 16 DO
         y2:=y2-dy;  y1:=y1-dy;
         Frame(x1+1,y1);
         graphics.setfillstyle(graphics.SOLID_FILL,0);
         graphics.bar(x1,y2,x2,y2+dy+6);
       END;
       graphics.bar(x1,y2-40,x2,y2);
END OpenFrame;

VAR WinRezMax, WinRezMax1 : WindowS.WinType;
PROCEDURE Rezjume;
VAR Delta2,Delta : LONGREAL;
    i            : CARDINAL;
    Yes          : CHAR;
BEGIN
 WindowS.PutOnTop(WinRezMax);
 OpenFrame;
 graphics.setfillstyle(graphics.SOLID_FILL,1);
 graphics.bar(2,1,638,30);
 graphics.setcolor(11);
 graphics.settextstyle(1,0,2);
 graphics.outtextxy(20,2,'All best approximations for array:');
 graphics.settextstyle(2,0,4); TextView.POSwGeneral:=28;
 Delta2:=1.E21;  Delta:=1.E11;
 i:=0; Len:=0.;
 LOOP INC(i);
    IF Kern.CollectionSp[i].Delta2<Delta2 THEN
       Delta2:=Kern.CollectionSp[i].Delta2;
       Wr(Kern.CollectionSp[i]);
       TextView.WrABCDco(Kern.CollectionSp[i])
    END;
    IF Kern.CollectionSm[i].Delta*Kern.CollectionSm[i].Delta<Delta*Delta THEN
       Delta:=Kern.CollectionSm[i].Delta;
       IF Kern.CollectionSm[i]#Kern.CollectionSp[i] THEN
          Wr(Kern.CollectionSm[i]);
          TextView.WrABCDco(Kern.CollectionSm[i])
       END
    END;
    IF (i>=Kern.ClassMax) OR (Len>10.) OR (TextView.POSwGeneral>330) THEN EXIT END;
 END;
 ColMin(380,1);
 Yes:=Menus.GetKey();
 graphics.setfillstyle(graphics.SOLID_FILL,0);
 graphics.bar(321,1,638,217);
 WindowS.Hide(WinRezMax);
 TextView.PutOnTop(TextView.WinFuDelt,1);
END Rezjume;

PROCEDURE RezjumeInFile;
VAR Delta2,Delta : LONGREAL;
    i            : CARDINAL;
    Yes          : CHAR;
BEGIN
 Delta2:=1.E21;  Delta:=1.E11;
 i:=0; Len:=0.;
 LOOP INC(i);
    IF Kern.CollectionSp[i].Delta2<Delta2 THEN
       Delta2:=Kern.CollectionSp[i].Delta2;
       TextView.WrInFile(Kern.CollectionSp[i]);
    END;
    IF Kern.CollectionSm[i].Delta*Kern.CollectionSm[i].Delta<Delta*Delta THEN
       Delta:=Kern.CollectionSm[i].Delta;
       IF Kern.CollectionSm[i]#Kern.CollectionSp[i] THEN
          TextView.WrInFile(Kern.CollectionSm[i]);
       END
    END;
    IF (i>=Kern.ClassMax) OR (Len>10.) THEN EXIT END;
 END;
 graphics.setfillstyle(graphics.SOLID_FILL,0);
 graphics.bar(2,1,638,TextView.POSwGeneral+12);
 TextView.PutOnTop(TextView.WinFuDelt,1);
END RezjumeInFile;

PROCEDURE WrMin(Fu:Kern.F;PosX,PosY:CARDINAL);
VAR D,SumM,Len1    : LONGREAL;
    i              : CARDINAL;
    DposX          : CARDINAL;
BEGIN
IF NOT Fu.Co THEN Fu:=Kern.Reform(Fu) END;
IF NOT Fu.Error THEN
  D:=Sqrt(Fu.Delta2)/LONGREAL(MuvMul.MaxPointNum)/(Kern.MaxY-Kern.MinY);
  IF D>1.E-10 THEN Len:=-Log10(D);  Len1:=Len*30.
  ELSE Len:=10.; Len1:=116.
  END;
  graphics.setcolor(Fu.BsY.Color);
  DposX:=12;
  graphics.line(PosX,PosY,PosX+DposX,PosY);
  PosX:=PosX+DposX;
  IF Len > 0. THEN
    IF Len1 > 116. THEN Len1:=116. END;
    SumM:=0.; FOR i:=1 TO Fu.Sp DO SumM:=SumM+ABS(Fu.M[i]) END;
    FOR i:=1 TO Fu.Sp DO
      IF SumM#0. THEN
       DposX:=TRUNC(ABS(Fu.M[i]*Len1/SumM));
       graphics.setcolor(Fu.BsX[i].Color);
       graphics.line(PosX,PosY,PosX+DposX,PosY);
       PosX:=PosX+DposX;
      END
    END
  END
 END (* not Error *)
END WrMin;

PROCEDURE ColMin(col,row : CARDINAL);
VAR Delta2,Delta : LONGREAL;
    i,ii,PosY    : CARDINAL;
BEGIN Frame(col,row);
(* Frame(492,167); *)
 Delta2:=1.E21;  Delta:=1.E11;  ii:=0;  i:=0;  Len:=0.;
 LOOP INC(i);
    IF Kern.CollectionSp[i].Delta2<Delta2 THEN
       Delta2:=Kern.CollectionSp[i].Delta2;
       INC(ii); PosY:=row+1+ii;  WrMin(Kern.CollectionSp[i],col+2,PosY);
       INC(ii); PosY:=row+1+ii;  WrMin(Kern.CollectionSp[i],col+2,PosY);
    END;
    IF Kern.CollectionSm[i].Delta*Kern.CollectionSm[i].Delta<Delta*Delta THEN
       Delta:=Kern.CollectionSm[i].Delta;
       INC(ii); PosY:=row+1+ii;  WrMin(Kern.CollectionSm[i],col+2,PosY);
       INC(ii); PosY:=row+1+ii;  WrMin(Kern.CollectionSm[i],col+2,PosY);
    END;
    IF (i>=Kern.ClassMax) OR (Len>10.) OR (PosY>row+44) THEN EXIT END;
 END;
END ColMin;

PROCEDURE Init;
BEGIN
 WinRezMin:=WindowS.Open(WindowS.WinDef(62,11,78,15,WindowS.LightCyan, WindowS.Black,
                         FALSE,FALSE,FALSE,FALSE,
                         WindowS.SingleFrame,WindowS.LightCyan, WindowS.Black));
 WinRezMax:=WindowS.Open(WindowS.WinDef(41,0,79,13,WindowS.LightCyan, WindowS.Black,
                         FALSE,FALSE,FALSE,FALSE,
                         WindowS.SingleFrame,WindowS.LightCyan, WindowS.Black));
END Init;
END Collect.
