
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE File;
IMPORT graphics,IO,FIO,Menus,WindowS,Kern,Progr,Str,
       MuvMul,Processs,TextView,ApView,MsMouse,BiosIO;


TYPE TypName=ARRAY [1..15]OF CHAR;
VAR  FileWin,WinInputName        : WindowS.WinType;
     DirName,FilName             : TypName;
     Ent                         : FIO.DirEntry;
     TimInformInit,Found         : BOOLEAN;
     F                           : FIO.File;


PROCEDURE GetName(VAR Name:TypName):BOOLEAN;
TYPE TyFil= RECORD    Info:ARRAY [1..40] OF CHAR;
                      N,
                      OutScreen: TypName;
                      POSwX,POSwY:CARDINAL;
            END;
VAR File         : ARRAY [0..14],[0..2] OF TyFil;
   PROCEDURE NameTransform(a,b:CARDINAL);
    TYPE TyMes = ARRAY [1..6] OF CHAR;
         SetTyMes = ARRAY [1..12] OF TyMes;
    CONST ConstMes=SetTyMes('-jan-','-feb-','-mar-','-apr-','-may-','-jun-',
                            '-jul-','-aug-','-sep-','-oct-','-nov-','-dec-');
    VAR l,I,Inf    : CARDINAL;
        ReturnName : TypName;
        ok     : BOOLEAN;
        SizNam : ARRAY [0..11] OF CHAR;
        Mes    : TyMes;
        Day,Hod: CARDINAL;
    BEGIN
           l:=Str.Pos(File[a,b].N,'.');
           File[a,b].OutScreen[1]:=File[a,b].N[1];
           FOR I:=1 TO l DO
            IF (65<=ORD(File[a,b].N[I]))AND(90>=ORD(File[a,b].N[I])) THEN
                File[a,b].OutScreen[I]:=CHR(ORD(File[a,b].N[I])+32)
            ELSE
                File[a,b].OutScreen[I]:=File[a,b].N[I]
            END;
            File[a,b].Info[I]:=File[a,b].OutScreen[I]; Inf:=I;
           END;
           INC(Inf); File[a,b].Info[Inf]:='.';
           FOR I:=l+1 TO 9 DO             File[a,b].OutScreen[I]:=' ' END;
           File[a,b].OutScreen[10]:='d';  File[a,b].OutScreen[11]:='a';
           File[a,b].OutScreen[12]:='t';  File[a,b].OutScreen[13]:=CHR(0);

           INC(Inf); File[a,b].Info[Inf]:='d'; INC(Inf); File[a,b].Info[Inf]:='a';
           INC(Inf); File[a,b].Info[Inf]:='t'; INC(Inf); File[a,b].Info[Inf]:=CHR(0);
           Str.Append(File[a,b].Info,'    ') ;
           Str.CardToStr(Ent.size,SizNam,10,ok);
           IF ok THEN Str.Append(File[a,b].Info,SizNam) END;
           Str.Append(File[a,b].Info,'    ') ;

           Day:= Ent.date MOD 32;
           Str.CardToStr(LONGCARD(Day),SizNam,10,ok);
           IF ok THEN Str.Append(File[a,b].Info,SizNam) END;

           Mes:= ConstMes[(Ent.date DIV 32) MOD 16];
           Str.Append(File[a,b].Info,Mes);

           Hod:= Ent.date DIV 512+1980;
           IF NOT TimInformInit THEN TimeInform:=Hod;
                                     TimInformInit:=TRUE
           END;
           Str.CardToStr(LONGCARD(Hod),SizNam,10,ok);
           IF ok THEN Str.Append(File[a,b].Info,SizNam) END;
   END NameTransform;

VAR View:BOOLEAN;
    i,iold :[0..14];     j,jold :[0..2];
    im,jm,ki,kj:CARDINAL;
    n,POSinfX,POSinfY      :CARDINAL;
    Yes    :CHAR;
    p1,p2,p3,p4,p5,p6: RECORD x,y:CARDINAL END;
CONST depth=7;
PROCEDURE ini():BOOLEAN;
  BEGIN
    View:=FALSE;
    Found:=FIO.ReadFirstEntry('*.dat',FIO.FileAttr(FIO.system),Ent);
    i:=0; j:=0; n:=0;
    graphics.setfillstyle(graphics.SOLID_FILL,1);
    graphics.bar(FileWin^.XA*8-8,FileWin^.YA*14-14,FileWin^.XB*8+15,FileWin^.YB*14+34);
    WindowS.PutOnTop(FileWin);     WindowS.Clear();
    WindowS.PutOnTop(FileWin);     WindowS.Clear();
    graphics.settextstyle(2,0,4);
    graphics.setcolor(3);
    graphics.outtextxy(FileWin^.XA*8,FileWin^.YB*14+22,'F3-view, F6-rename, F8-del, Enter, Esc');
    graphics.setcolor(14);
    graphics.outtextxy(FileWin^.XA*8,FileWin^.YA*14,   '    Name         Name         Name');
    graphics.setcolor(11);
    POSinfX:=(FileWin^.XA)*8; POSinfY:=(depth+FileWin^.YA)*14+16;
    IF NOT Found THEN
        graphics.outtextxy(370,80,' FILES: *.dat  NOT FOUND ');
        Yes:=Menus.GetKey();
        Name:=' '; WindowS.Hide(FileWin);
        RETURN FALSE
    ELSE
       WHILE Found AND (n<=19) DO
         File[i,j].N:=TypName(Ent.Name);
         NameTransform(i,j);
         File[i,j].POSwX:=(j*10+FileWin^.XA)*8; File[i,j].POSwY:=(i+FileWin^.YA)*14+14;
         graphics.outtextxy(File[i,j].POSwX,File[i,j].POSwY,File[i,j].OutScreen);
         INC(i); INC(n);
         IF i=depth THEN j:=j+1; i:=0 END;
         Found:=FIO.ReadNextEntry(Ent)
       END;
       p1.x:=FileWin^.XA*8-5;              p1.y:=(depth+FileWin^.YA)*14+14;
       p2.x:=FileWin^.XB*8+11;             p2.y:=p1.y;
       p3.x:=p1.x+(p2.x-p1.x) DIV 3;       p4.x:=p3.x;
       p5.x:=p3.x+(p2.x-p1.x) DIV 3;       p6.x:=p5.x;
       p3.y:=FileWin^.YA*14;               p5.y:=p3.y;
       p4.y:=p1.y;                         p6.y:=p1.y;
       graphics.line(p1.x,p1.y,p2.x,p2.y); graphics.line(p3.x,p3.y,p4.x,p4.y);
       graphics.line(p5.x,p5.y,p6.x,p6.y);
       i:=0; j:=0;
       graphics.outtextxy(POSinfX,POSinfY,File[i,j].Info);
       graphics.setfillstyle(graphics.SOLID_FILL,3);
       graphics.bar(File[i,j].POSwX-1,File[i,j].POSwY+2,File[i,j].POSwX+71,File[i,j].POSwY+12);
       graphics.setcolor(0);
       graphics.outtextxy(File[i,j].POSwX,File[i,j].POSwY,File[i,j].OutScreen);
       iold:=0;jold:=0;
       RETURN TRUE
     END
    END ini;

 VAR NewName         : TypName;
     Dat             : MsMouse.MsData;
     mp              : MsMouse.MsRange;
     n2              : CARDINAL;
 BEGIN
   IF ini() THEN
    IF Menus.IniMous<10 THEN
        mp:=MsMouse.MsRange(630,300,200,5); MsMouse.SetRange(mp);
    END;
       LOOP
          IF Menus.IniMous<10 THEN MsMouse.Cursor(TRUE) END;
          Yes:= Menus.GetKey();
          IF Menus.IniMous<10 THEN MsMouse.GetPress(0,Dat);Menus.Pip;
                                   MsMouse.Cursor(FALSE) END;
          CASE Yes OF
           | 'l': ki:=0; kj:=0; im:=100; jm:=100;
                 WHILE (ki+1+kj*depth<=n) DO
                    IF (File[ki,kj].POSwY+2<CARDINAL(Dat.row))  AND
                       (CARDINAL(Dat.row)<File[ki,kj].POSwY+12) AND
                       (File[ki,kj].POSwX-1<CARDINAL(Dat.col))  AND
                       (CARDINAL(Dat.col)<File[ki,kj].POSwX+71) THEN
                       im:=ki;  jm:=kj;
                    END;
                    INC(ki);
                    IF ki=depth THEN kj:=kj+1; ki:=0 END;
                  END;
                  IF (im>=0) AND (jm>=0) AND (jm*depth+im+1<=n) THEN
                     IF (i=im) AND (j=jm) THEN Yes:=CHR(13);
                     ELSE i:=im; j:=jm; Yes:='s';
                     END
                  ELSE Yes:='s';
                  END;
          END;
          CASE Yes OF
            | CHR(128+75) : IF j#0 THEN j:=j-1 END;
            | CHR(128+77) : IF (j+1)*depth+i+1<=n THEN j:=j+1 END;
            | CHR(128+72) : IF i#0 THEN i:=i-1 END;
            | CHR(128+80) : IF (j*depth+i+2<=n)AND(i<depth-1) THEN i:=i+1 END;
            | CHR(27),'r' : Name:=' ';WindowS.Hide(FileWin);
              graphics.setfillstyle(graphics.SOLID_FILL,0);
              graphics.bar(FileWin^.XA*8-8,FileWin^.YB*14+21,FileWin^.XB*8+15,FileWin^.YB*14+34);
              IF Menus.IniMous<10 THEN
                 mp:=MsMouse.MsRange(630,10,345,1); MsMouse.SetRange(mp);
              END;
              RETURN FALSE; EXIT;
            | CHR(13): Name:=File[i,j].N;WindowS.Hide(FileWin);
              graphics.setfillstyle(graphics.SOLID_FILL,0);
              graphics.bar(FileWin^.XA*8-8,FileWin^.YB*14+21,FileWin^.XB*8+15,FileWin^.YB*14+34);
              IF Menus.IniMous<10 THEN
                 mp:=MsMouse.MsRange(630,10,345,1); MsMouse.SetRange(mp);
              END;
              RETURN TRUE; EXIT
            | CHR(128+66) : FIO.Erase(File[i,j].N);
              WindowS.Hide(FileWin);IF NOT ini() THEN RETURN FALSE; EXIT END;
            | CHR(128+61) : IF View THEN View:=FALSE ELSE View:=TRUE END;
            | CHR(128+64) :
              Menus.ClearAnounse();
(*            Menus.WrStrAnounse( FALSE,'Enter the name');
              *)
              Menus.WrStrAnounse( FALSE,'  䠩 ( ७) ');
              Menus.WrStrAnounse( FALSE,'                                 ');
              Menus.WrStrAnounse( FALSE,'                                 ');
               WindowS.Use(WinInputName);
(*             IO.WrStr('File name =');
               *)
               IO.WrStr('=');
               IO.RdStr(NewName);
               Str.Append(NewName,'.dat');
               WindowS.Hide(Menus.Anounse);WindowS.Hide(WinInputName);
               FIO.Rename(File[i,j].N,NewName);
               WindowS.Hide(FileWin);
               IF NOT ini() THEN
                 IF Menus.IniMous<10 THEN
                    mp:=MsMouse.MsRange(630,10,345,1); MsMouse.SetRange(mp);
                 END;
                 RETURN FALSE; EXIT
               END;
          END;(*case*) (* Menus.Pip;*)

          graphics.setfillstyle(graphics.SOLID_FILL,1);
          graphics.bar(POSinfX-1,POSinfY+2,POSinfX+200,POSinfY+12);
          graphics.bar(File[iold,jold].POSwX-1,File[iold,jold].POSwY+2,File[iold,jold].POSwX+71,File[iold,jold ].POSwY+12);
          graphics.setcolor(11);
          graphics.outtextxy(POSinfX,POSinfY,File[i,j].Info);
          graphics.outtextxy(File[iold,jold].POSwX,File[iold,jold].POSwY,File[iold,jold].OutScreen);
          jold:=j; iold:=i;

          graphics.setfillstyle(graphics.SOLID_FILL,3);
          graphics.bar(File[i,j].POSwX-1,File[i,j].POSwY+2,File[i,j].POSwX+71,File[i,j].POSwY+12);
          graphics.setcolor(0);
          graphics.outtextxy(File[i,j].POSwX,File[i,j].POSwY,File[i,j].OutScreen);
          IF View THEN
            MuvMul.Ka:=0.; MuvMul.Kb:=0.;
            MuvMul.Kc:=1.; MuvMul.Kd:=1.; MuvMul.Mode:=MuvMul.TypMode{};
            MuvMul.WrF:= MuvMul.WrConst;
            MuvMul.WrFx:= MuvMul.WrF[MuvMul.x];
            MuvMul.WrFy:= MuvMul.WrF[MuvMul.y];
            F:=FIO.Open(File[i,j].N);
            MuvMul.MaxPointNum:=0;
            LOOP INC(MuvMul.MaxPointNum);
              IF MuvMul.MaxPointNum>MuvMul.MaxArray THEN DEC(MuvMul.MaxPointNum);EXIT END;
              MuvMul.X^[MuvMul.MaxPointNum]:=FIO.RdLngReal(F);
              IF FIO.EOF THEN DEC(MuvMul.MaxPointNum);EXIT END;
              MuvMul.Y^[MuvMul.MaxPointNum]:=FIO.RdLngReal(F);
              MuvMul.Xold^[MuvMul.MaxPointNum]:=MuvMul.X^[MuvMul.MaxPointNum];
              MuvMul.Yold^[MuvMul.MaxPointNum]:=MuvMul.Y^[MuvMul.MaxPointNum];
            END;  (* loop *)
            FIO.Close(F);
            Kern.MinX:=1.E10; Kern.MinY:=1.E10; Kern.MaxX:=-1.E10; Kern.MaxY:=-1.E10;
            FOR n2:=1 TO MuvMul.MaxPointNum DO
              IF  Kern.MinY > MuvMul.Yold^[n2] THEN Kern.MinY:=MuvMul.Yold^[n2] END;
              IF  Kern.MinX > MuvMul.Xold^[n2] THEN Kern.MinX:=MuvMul.Xold^[n2] END;
              IF  MuvMul.Yold^[n2] > Kern.MaxY THEN Kern.MaxY:=MuvMul.Yold^[n2] END;
              IF  MuvMul.Xold^[n2] > Kern.MaxX THEN Kern.MaxX:=MuvMul.Xold^[n2] END;
            END;
            ApView.Picture(0);
          END  (* View *)
       END; (* loop *)
   END (* not found *)
END GetName;

VAR SmolFilName : TypName;

PROCEDURE SaveMod;
 BEGIN Progr.Mod(SmolFilName,F)
END SaveMod;

VAR I:CARDINAL;
PROCEDURE SaveDat;
 BEGIN
  IF (MuvMul.XYty IN MuvMul.Mode) THEN
            FOR  I:=1 TO MuvMul.MaxPointNum DO
                FIO.WrLngReal(F,MuvMul.Yold^[I],5,12);
                FIO.WrLngReal(F,MuvMul.Xold^[I],5,12); FIO.WrLn(F);
            END
  ELSE      FOR  I:=1 TO MuvMul.MaxPointNum DO
                FIO.WrLngReal(F,MuvMul.Xold^[I],5,12);
                FIO.WrLngReal(F,MuvMul.Yold^[I],5,12); FIO.WrLn(F);
            END
  END
END SaveDat;

VAR Drive : SHORTCARD;
    n     : CARDINAL;
PROCEDURE Save(P:PROC; SUB:ARRAY OF CHAR);
 VAR Yes  : CHAR;
 BEGIN
    Menus.ClearAnounse();
(*     Menus.WrStrAnounse( FALSE,'Enter the name (without extension)');
       *)
       Menus.WrStrAnounse( FALSE,'  䠩 ( ७) ');
       Menus.WrStrAnounse( FALSE,'                                 ');
       Menus.WrStrAnounse( FALSE,'                                 ');
     WindowS.Use(WinInputName);
     IO.WrStr(' = ');
     IO.RdStr(SmolFilName);
     WindowS.Hide(Menus.Anounse);WindowS.Hide(WinInputName);
     Str.Concat(FilName,SmolFilName,'.');
     Str.Append(FilName,SUB);
     Yes:='N';
     IF FIO.Exists(FilName) THEN
    (*
       Menus.WrStrAnounse( FALSE,'      The file of the same name    ');
       Menus.WrStrAnounse( FALSE,' already exists.                   ');
       Menus.WrStrAnounse( FALSE,'      Overwrite?       (Y/N)       ');
       *)
       Menus.WrStrAnounse( FALSE,'   ⠪  㦥 ');
       Menus.WrStrAnounse( FALSE,'                                   ');
       Menus.WrStrAnounse( FALSE,'  ᢥ?        (Y/N)       ');
       Yes:=Menus.GetKey();
       WindowS.Hide(Menus.Anounse);
     END;
     IF (Yes='y') OR (Yes='Y') OR (Yes='l') OR (NOT FIO.Exists(FilName)) THEN
       F:=FIO.Create(FilName);
       P;
       FIO.Close(F);
       MuvMul.QuestionSave:=FALSE
     ELSE
(*     Menus.WrStrAnounse( FALSE,'  Active case has not been saved. ');
       *)
       Menus.WrStrAnounse( FALSE,'         ᠭ.      ');
       Menus.WrStrAnounse( FALSE,'                                   ');
       Menus.WrStrAnounse( TRUE ,'                                   ');
       WindowS.Hide(Menus.Anounse);
     END
END Save;

PROCEDURE SaveIF;
 VAR Yes:CHAR;
 BEGIN
  IF MuvMul.QuestionSave THEN
(*             Menus.WrStrAnounse( FALSE,'  Active case has not been saved. ');
               Menus.WrStrAnounse( FALSE,'  Do you want to save             ');
               Menus.WrStrAnounse( FALSE,'    before leaving?       (Y/N)   ');
*)
               Menus.WrStrAnounse( FALSE,'       뫨   ࠭   ');
               Menus.WrStrAnounse( FALSE,'                   䠩 ?   ');
               Menus.WrStrAnounse( FALSE,'       ?       (Y/N)   ');
               Yes:=Menus.GetKey();
               IF (Yes='y') OR (Yes='Y') OR (Yes='l') THEN Save(SaveDat,'dat');
               ELSE
               END;
               WindowS.Hide(Menus.Anounse);
  END;
END SaveIF;

VAR OldName:TypName;
PROCEDURE Load(First:CARDINAL):BOOLEAN;
BEGIN
            OldName:=FilName; (* for unerase *)
            SaveIF;
            MuvMul.MaxPointNum:=0;
            IF GetName(FilName) THEN OldName:=FilName (* load new file *)
            ELSE     IF First=1 THEN RETURN FALSE
                     ELSE            FilName:=OldName (* load old file *)
                     END
            END;
            MuvMul.Ka:=0.; MuvMul.Kb:=0.;
            MuvMul.Kc:=1.; MuvMul.Kd:=1.;
            MuvMul.Mode:=MuvMul.TypMode{};
            MuvMul.WrF:= MuvMul.WrConst;
            MuvMul.WrFx:= MuvMul.WrF[MuvMul.x];
            MuvMul.WrFy:= MuvMul.WrF[MuvMul.y];
            F:=FIO.Open(FilName);
            MuvMul.MaxPointNum:=0;
            LOOP INC(MuvMul.MaxPointNum);
              IF MuvMul.MaxPointNum>12(*MuvMul.MaxArray*) THEN DEC(MuvMul.MaxPointNum);EXIT END;
              MuvMul.X^[MuvMul.MaxPointNum]:=FIO.RdLngReal(F);
              IF FIO.EOF THEN DEC(MuvMul.MaxPointNum);EXIT END;
              MuvMul.Y^[MuvMul.MaxPointNum]:=FIO.RdLngReal(F);
              MuvMul.Xold^[MuvMul.MaxPointNum]:=MuvMul.X^[MuvMul.MaxPointNum];
              MuvMul.Yold^[MuvMul.MaxPointNum]:=MuvMul.Y^[MuvMul.MaxPointNum];
            END;
            FIO.Close(F);
            Processs.IniSiKoff:=FALSE;
            Processs.IniSi:=FALSE;
            Kern.ToRecalculation;
            TextView.PutOnTop(TextView.WinFuDelt,1);
            Processs.ProcessI(Processs.TopSpis,0,TRUE);
       (*   Menus.CommandESC(Men2);    *)
            MuvMul.QuestionSave:=FALSE;
            RETURN TRUE
END Load;

PROCEDURE Init;
BEGIN
 FileWin:= WindowS.Open( WindowS.WinDef(48,0,78,10,WindowS.LightGreen,WindowS.White,
      FALSE,TRUE,FALSE,TRUE,WindowS.SingleFrame,WindowS.LightGreen, WindowS.White));
 FIO.GetDir(0,DirName);
 Drive:=FIO.GetDrive();
 Str.Concat(DirName,':',DirName); Str.Concat(DirName,CHR(Drive+64),DirName);
 Str.Concat(DirName,' ',DirName); Str.Concat(DirName,DirName,' ');
 WindowS.SetTitle( FileWin,DirName,WindowS.CenterUpperTitle);

 WinInputName:= WindowS.Open(WindowS.WinDef(50,13,75,15,WindowS.LightGray, WindowS.Black,
      FALSE,TRUE,TRUE,TRUE,WindowS.SingleFrame,WindowS.LightGray, WindowS.Black));
(* WindowS.SetTitle( WinInputName,'To enter file name',WindowS.CenterUpperTitle);
   *)
   WindowS.SetTitle( WinInputName,'   䠩',WindowS.CenterUpperTitle);
TimInformInit:=FALSE
END Init;
END File.


