
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE GrfMeinS;
IMPORT graphics;
FROM IO IMPORT    WrLngReal,RdLngReal,RdCard,WrStr,WrChar,WrCard,
                  WrInt,RdCard,WrLn;
IMPORT Storage, WindowS, Lib, SYSTEM, Menus, Str;
IMPORT MsMouse;

PROCEDURE Pont(S:UcScreen;Dot:Playground;VAR DotG:PlaygroundG);
BEGIN WITH S^ DO

        DotG[WestEast] :=BorderG[West]+INTEGER(
                     (Dot[WestEast]-Border[West])
                    /(Border[East]-Border[West])
                    *LONGREAL(BorderG[East]-BorderG[West])
                                                );

        DotG[SouthNort]:=BorderG[South]-INTEGER(
                     (Dot[SouthNort]-Border[South])
                    /(Border[Nort]-Border[South])
                    *LONGREAL( BorderG[South]-BorderG[Nort])
                                                 );

        DotG[DownUp]   := INTEGER(
                     (Dot[DownUp]-Border[Down])
                    /(Border[Up]-Border[Down])
                    *LONGREAL(graphics.MAXCOLORS)
                                  );
        IF DotG[DownUp]=8 THEN DotG[DownUp]:=15  END
      END
END Pont;
PROCEDURE Out(S:UcScreen;Dot:Playground):BOOLEAN;
  VAR  Dir      : Direction;
       BorderOut: ARRAY Direction OF BOOLEAN;
  BEGIN
    WITH S^ DO
     BorderOut[West] := Dot[WestEast]  < Border[West];
     BorderOut[East] := Dot[WestEast]  > Border[East];
     BorderOut[South]:= Dot[SouthNort] > Border[Nort];
     BorderOut[Nort] := Dot[SouthNort] < Border[South];
     BorderOut[Down] := Dot[DownUp]    < Border[Down];
     BorderOut[Up]   := Dot[DownUp]    > Border[Up];
     FOR Dir:=West TO  Up  DO
                      IF BorderOut[Dir] THEN   RETURN TRUE
                      END
     END;
     RETURN FALSE
   END
END Out;

PROCEDURE GrKoord(  W : WinType);
VAR   S    : UcScreen;
      DotG : PlaygroundG;
      Dot  : Playground;
      N5,W5,S5,E5:INTEGER;
      marc : ARRAY [0..9] OF CHAR;
      OK   : BOOLEAN;
      I           : CARDINAL;
      Atest,Btest : LONGREAL;
BEGIN
 graphics.settextstyle(2,0,4);
 S:=W^.UserRecord;
 (*graphics.setactivepage(S^.Page);*)
 graphics.setcolor(INTEGER(W^.WDef.FrameFore));
 WITH S^ DO
       N5:=BorderG[Nort]+5; S5:=BorderG[South]-5;
       W5:=BorderG[West]+5;   E5:=BorderG[East]-5;
       graphics.setfillstyle(graphics.SOLID_FILL,INTEGER(W^.WDef.Background));
       graphics.bar(W5-4,N5-8,E5+8,S5+5);
       graphics.setfillstyle(graphics.SOLID_FILL,0);
       graphics.bar(W5-4,S5+5,E5+8,S5+15);
       Dot:=BeginKoord;     Dot[WestEast]:=Border[West];
       FOR I:=1 TO 5 DO
          Pont(S,Dot,DotG);
          graphics.setcolor(11);
          graphics.line(DotG[WestEast],BorderG[Nort],DotG[WestEast],N5);
          graphics.line(DotG[WestEast],S5,DotG[WestEast],BorderG[South]);
          Str.RealToStr(Dot[WestEast],3,TRUE,marc,OK);
          IF OK THEN graphics.setcolor(15);
                     graphics.outtextxy(DotG[WestEast],BorderG[South],marc)
          END;
          Atest:=Dot[WestEast]+(Border[East]-Border[West])/5.;
          IF Dot[WestEast]#0. THEN
              Btest:=ABS(Atest/Dot[WestEast]);
              IF Btest<1.E-6 THEN Dot[WestEast]:=0.
              ELSE               Dot[WestEast]:=Atest
              END
          ELSE Dot[WestEast]:=Atest
          END
       END;
       Dot:=BeginKoord;       Dot[SouthNort]:=Border[South];
       WHILE Dot[SouthNort]<Border[Nort] DO
          Atest:=Dot[SouthNort]+(Border[Nort]-Border[South])/5.;
          IF Dot[SouthNort]#0. THEN
              Btest:=ABS(Atest/Dot[SouthNort]);
              IF Btest<1.E-6 THEN Dot[SouthNort]:=0.
              ELSE               Dot[SouthNort]:=Atest
              END
          ELSE Dot[SouthNort]:=Atest
          END;
          Pont(S,Dot,DotG);
          graphics.setcolor(11);
          graphics.line(BorderG[West],DotG[SouthNort],W5,DotG[SouthNort]);
          graphics.line(E5,DotG[SouthNort],BorderG[East],DotG[SouthNort]);
          Str.RealToStr(Dot[SouthNort],3,TRUE,marc,OK);
          IF OK THEN graphics.setcolor(15);
                     graphics.outtextxy(BorderG[West],DotG[SouthNort],marc)
          END;
       END;
   graphics.setcolor(11);
   graphics.line(BorderG[West],BorderG[Nort],BorderG[West],BorderG[South]);
   graphics.line(BorderG[East],BorderG[Nort],BorderG[East],BorderG[South]);
   graphics.line(BorderG[West],BorderG[Nort],BorderG[East],BorderG[Nort]);
   graphics.line(BorderG[West],BorderG[South],BorderG[East],BorderG[South]);
END  (* with ScrenTest *)
END GrKoord;

PROCEDURE WrLineCol( W : WinType; X,Y: LONGREAL; Col:CARDINAL);
VAR   S   :UcScreen;
      DotG : PlaygroundG;
      Dot  : Playground;
BEGIN S:=W^.UserRecord;
      graphics.setactivepage(S^.Page);
      WITH S^ DO
        Dot[WestEast]:=X; Dot[SouthNort]:=Y; Dot[DownUp]:=5.;
          IF NOT Out(S,Dot)  THEN
            Pont(S,Dot,DotG);
            IF NOT DotMemoryAut THEN
               graphics.setcolor(Col);
               graphics.line(DotG[WestEast],DotG[SouthNort],
           	  DotMemory[WestEast],DotMemory[SouthNort])
            END;	
            DotMemory:=DotG; DotMemoryAut:=FALSE
          ELSE (* Out *) DotMemoryAut:=TRUE
          END	
       END
END WrLineCol;

PROCEDURE WrMarcer( W : WinType; X,Y,Z : LONGREAL);
VAR   S         : UcScreen;
      DotG      : PlaygroundG;
      Dot       : Playground;
      I         : INTEGER;
BEGIN
  S:=W^.UserRecord;
  WITH S^ DO Dot[WestEast]:=X; Dot[SouthNort]:=Y; Dot[DownUp]:=Z;
      DotMemoryAut:=TRUE;
      IF NOT Out(S,Dot)  THEN  Pont(S,Dot,DotG);
       IF DotG[DownUp]=INTEGER(graphics.getpixel(DotG[WestEast],DotG[SouthNort])) THEN
               IF DotG[DownUp]<>15 THEN  DotG[DownUp]:=15
               ELSE DotG[DownUp]:=10
               END;
       END;
       FOR I:=1 TO 5 DO
         graphics.putpixel(MemScrin[WestEast],MemScrin[SouthNort]+I-3,AltScrin[I,V]);
         graphics.putpixel(MemScrin[WestEast]+I-3,MemScrin[SouthNort],AltScrin[I,G]);
       END;
       FOR I:=1 TO 5 DO
         AltScrin[I,G]:= graphics.getpixel(DotG[WestEast]+I-3,DotG[SouthNort]);
         graphics.putpixel(DotG[WestEast]+I-3,DotG[SouthNort],DotG[DownUp]);
         AltScrin[I,V]:= graphics.getpixel(DotG[WestEast],    DotG[SouthNort]+I-3);
         graphics.putpixel(DotG[WestEast],DotG[SouthNort]+I-3,DotG[DownUp]);
       END;
       MemScrin:=DotG; DotMemory:=MemScrin; AltScrin[3,V]:=AltScrin[3,G];
       DotMemoryAut:=FALSE
     ELSE (* Menus.Pip;*)
         Second[WestEast] :=Border[West] +(Border[East]-Border[West])/2.;
         Second[SouthNort]:=Border[South]+(Border[Nort]-Border[South])/2.;
         Second[DownUp]   :=Border[Down] +(Border[Up]-Border[Down])/2.;
       END	
 END

END WrMarcer;

PROCEDURE WrPoint( W : WinType; X,Y,Z : LONGREAL);
VAR   S         : UcScreen;
      DotG      : PlaygroundG;
      Dot       : Playground;
BEGIN S:=W^.UserRecord;
    graphics.setactivepage(S^.Page);
    WITH S^ DO Dot[WestEast]:=X; Dot[SouthNort]:=Y; Dot[DownUp]:=Z;
      IF NOT Out(S,Dot)  THEN  Pont(S,Dot,DotG);
           graphics.putpixel(DotG[WestEast],DotG[SouthNort],DotG[DownUp]);
           graphics.setcolor(DotG[DownUp]);
           DotMemory:=DotG;  DotMemoryAut:=FALSE;
       END	
    END  (* WITH *)
END WrPoint;

PROCEDURE WrCircle( W : WinType; X,Y,Z : LONGREAL);
VAR   S         : UcScreen;
      DotG      : PlaygroundG;
      Dot       : Playground;
BEGIN S:=W^.UserRecord;
    graphics.setactivepage(S^.Page);
    WITH S^ DO Dot[WestEast]:=X; Dot[SouthNort]:=Y; Dot[DownUp]:=Z;
      IF NOT Out(S,Dot)  THEN  Pont(S,Dot,DotG);
           graphics.setcolor(15);
           graphics.circle(DotG[WestEast],DotG[SouthNort],4);
           DotMemory:=DotG;  DotMemoryAut:=FALSE;
       END	
    END  (* WITH *)
END WrCircle;

PROCEDURE RdPoint(W:WinType;VAR X,Y:LONGREAL;VAR Z:CHAR);
VAR   S    : UcScreen;
      C    : CHAR;
      I    : INTEGER;
      mar  : ARRAY [0..11] OF CHAR;
      OK   : BOOLEAN;
      Dat             : MsMouse.MsData;
      First           : Playground;
BEGIN
     S:=W^.UserRecord;
     graphics.setcolor(15);  graphics.setfillstyle(graphics.SOLID_FILL,1);
     FOR I:=1 TO 5 DO
         S^.AltScrin[I,V]:=0; S^.AltScrin[I,G]:=4;
     END;
     WITH S^ DO Z:='F';
     mar[0]:=CHR(0);
          LOOP
             WrMarcer(W,Second[WestEast],Second[SouthNort],Second[DownUp]);
             X:=Second[WestEast];   Y:=Second[SouthNort];
             WindowS.GotoXY(1,2);
             graphics.bar(TextWin^.XA*8+8,TextWin^.YA*14+14,
                          TextWin^.XB*8-10,TextWin^.YB*14);
             Str.RealToStr(X,5,TRUE,mar,OK);
             IF OK THEN graphics.outtextxy(TextWin^.XA*8+8,TextWin^.YA*14+14,mar)
             END;
             Str.RealToStr(Y,5,TRUE,mar,OK);
             IF OK THEN graphics.outtextxy(TextWin^.XA*8+8,TextWin^.YA*14+28,mar)
             END;
             IF Menus.IniMous<10 THEN MsMouse.Cursor(TRUE) END;
             C:= Menus.GetKey();
             IF Menus.IniMous<10 THEN MsMouse.GetPress(0,Dat);
                                      MsMouse.Cursor(FALSE)
             END;
             CASE C OF
               | CHR(128+83):IF Z='T' THEN Z:='D' END; EXIT;
               | CHR(13): EXIT;
               | CHR(128+75) : Second[WestEast] :=Second[WestEast]-StepMarc[WestEast];Z:='T';
               | CHR(128+77) : Second[WestEast] :=Second[WestEast]+StepMarc[WestEast];Z:='T';
               | CHR(128+72) : Second[SouthNort]:=Second[SouthNort]+StepMarc[SouthNort];Z:='T';
               | CHR(128+80) : Second[SouthNort]:=Second[SouthNort]-StepMarc[SouthNort];Z:='T';
               | '+':  StepMarc[WestEast] :=StepMarc[WestEast]*2.;
                       StepMarc[SouthNort]:=StepMarc[SouthNort]*2.;
                       StepMarc[DownUp]   :=StepMarc[DownUp]*2.;
               | '-':  StepMarc[WestEast] :=StepMarc[WestEast]/2.;
                       StepMarc[SouthNort]:=StepMarc[SouthNort]/2.;
                       StepMarc[DownUp]   :=StepMarc[DownUp]/2.;
               | 'l':  IF (330<Dat.row) AND (Dat.row<345) THEN
                          IF (307<Dat.col) AND (Dat.col<427) AND (First#Second)
                              THEN Z:='T'; First:=Second; EXIT
                          END;
                          IF (427<Dat.col) AND (Dat.col<541) THEN Z:='D'; EXIT
                          END;
                          IF (550<Dat.col) AND (Dat.col<635) THEN Z:='F'; EXIT
                          END
                       ELSE Second[WestEast]:=Border[West]+
                                LONGREAL(Dat.col-BorderG[West])/
                                LONGREAL(BorderG[East]-BorderG[West])
                                            *(Border[East]-Border[West]);
                            Second[SouthNort]:=Border[Nort]+
                                LONGREAL(Dat.row-BorderG[Nort])/
                                LONGREAL(BorderG[South]-BorderG[Nort])
                                            *(Border[South]-Border[Nort]);
                       END
            ELSE   Z:='F'; EXIT;
            END;  (* Menus.Pip*)  (*Case*)
          END (*Loop*)
    END (* With *)
END RdPoint;


PROCEDURE Info( W : WinType):ScrType;
BEGIN  RETURN  W^.UserRecord;
END Info;

PROCEDURE SetBorderG(W:WinType);
VAR   S   :UcScreen;
      CharPicsW,CharPicsD:INTEGER;
BEGIN CharPicsW:=graphics.getmaxx() DIV INTEGER(WindowS.ScreenWidth)+1;
      CharPicsD:=graphics.getmaxy() DIV INTEGER(WindowS.ScreenDepth)+1;
      S:=W^.UserRecord;
      S^.BorderG[West] :=INTEGER(W^.XA)* CharPicsW+10;
      S^.BorderG[Nort] :=INTEGER(W^.YA)* CharPicsD+6;
      S^.BorderG[East] :=INTEGER((W^.XB+1))* CharPicsW-10;
      S^.BorderG[South]:=INTEGER((W^.YB+1))* CharPicsD-10;
      S^.BorderG[Down] :=0;
      S^.BorderG[Up]   :=16;
END SetBorderG;

PROCEDURE SetPage( W : WinType; P : CARDINAL);
VAR   S   :UcScreen;
BEGIN S:=W^.UserRecord;
      S^.Page:=P;
END SetPage;

PROCEDURE Open( W : WinType);
VAR    X1t,Y1t,X2t,Y2t:CARDINAL;
       S   :UcScreen;
       WD  :WindowS.WinDef;
       I   :INTEGER;
BEGIN
  Storage.ALLOCATE(S,SIZE(Screen));
  W^.UserRecord:=S;
  SetBorderG(W);
  S^.MemScrin[WestEast]:=2;   S^.MemScrin[SouthNort]:=2;
  SetBegKor( W,  0., 0., 5.  );
  SetBorderX(W, -1., 1. );
  SetBorderY(W, -1., 1. );
  SetBorderZ(W,  0., 16.);
     WITH W^ DO
       S:=UserRecord;
       WD:=WindowS.WinDef( 1,2,1,2,WindowS.Green,WindowS.White,FALSE,FALSE,TRUE,
                         FALSE,WindowS.SingleFrame,WindowS.Green,WindowS.White);
       WD.FrameFore:=W^.WDef.FrameFore;  WD.FrameBack:=W^.WDef.FrameBack;
       S^.TextWin:= WindowS.Open(WD);
       S^.Page:= 0;
       X2t:=W^.WDef.X2; X1t:=X2t-10; Y2t:=W^.WDef.Y2; Y1t:=Y2t-3;
       WindowS.Change(S^.TextWin,X1t,Y1t,X2t,Y2t);
    END
END Open;

PROCEDURE SetTitle( W :WinType; Title :ARRAY OF CHAR; Mode:TitleMode);
 VAR      S       : UcScreen;
          Name    : ARRAY [0..35] OF CHAR;
          I,Max   : CARDINAL;
 BEGIN  Max:=HIGH(Title);
        FOR I:=0 TO Max DO
          Name[I]:=Title[I]
        END;
        WindowS.SetTitle( W,Title,WindowS.CenterUpperTitle);
        WITH W^ DO  S:=UserRecord;
          WindowS.SetTitle( S^.TextWin,
                         Name,WindowS.CenterUpperTitle);
        END
END SetTitle;

PROCEDURE SetBegKor( W : WinType; BegKorX,BegKorY,BegKorZ : LONGREAL);
VAR   S   :UcScreen;
BEGIN S:=W^.UserRecord;
      WITH S^ DO
       BeginKoord[WestEast]:=BegKorX;
       BeginKoord[SouthNort]:=BegKorY;
       BeginKoord[DownUp]:=BegKorZ;
      END
END SetBegKor;

PROCEDURE SetBorderX( W : WinType; BordW,BordE : LONGREAL);
VAR   S   :UcScreen;
BEGIN S:=W^.UserRecord;
      WITH S^ DO
       Border[West]:=BordW; Border[East]:=BordE;
       StepMarc[WestEast] :=(Border[East]-Border[West])/20.;
       Second[WestEast]   :=Border[West]+(Border[East]-Border[West])/2.;
      END;
      SetBorderG(W)
END SetBorderX;

PROCEDURE SetBorderY( W : WinType; BordS,BordN : LONGREAL);
VAR   S   :UcScreen;
BEGIN S:=W^.UserRecord;
      WITH S^ DO
       Border[South]:=BordS; Border[Nort]:=BordN;
       StepMarc[SouthNort]:=(Border[Nort]-Border[South])/20.;
       Second[SouthNort]  :=Border[South]+(Border[Nort]-Border[South])/2.;
      END;
      SetBorderG(W)
END SetBorderY;

PROCEDURE SetBorderZ( W : WinType; BordD,BordU : LONGREAL);
VAR   S   :UcScreen;
BEGIN S:=W^.UserRecord;
      WITH S^ DO
       Border[Down]:=BordD; Border[Up]:=BordU;
       StepMarc[DownUp]   :=(Border[Up]-Border[Down])/20.;
       Second[DownUp]     :=Border[Down]+(Border[Up]-Border[Down])/2.;
      END;
      SetBorderG(W)
END SetBorderZ;


PROCEDURE SetKoordAxis( W : WinType; K : KrdAxisType);
VAR   S   :UcScreen;
BEGIN WITH W^ DO
         S:=UserRecord;
         S^.KoordAxis:= K;
      END
END SetKoordAxis;

PROCEDURE OutCorrector(S:UcScreen;VAR Dot:Playground);
VAR  Dir      : Direction;
     BorderOut: ARRAY Direction OF BOOLEAN;
BEGIN
 WITH S^ DO
  IF Dot[WestEast]  < Border[West]  THEN Dot[WestEast] :=Border[West] END;
  IF Dot[WestEast]  > Border[East]  THEN Dot[WestEast] :=Border[East] END;
  IF Dot[SouthNort] > Border[Nort]  THEN Dot[SouthNort]:=Border[Nort] END;
  IF Dot[SouthNort] < Border[South] THEN Dot[SouthNort]:=Border[South]END;
  IF Dot[DownUp]    < Border[Down]  THEN Dot[DownUp]   :=Border[Down] END;
  IF Dot[DownUp]    > Border[Up]    THEN Dot[DownUp]   :=Border[Up]   END;
END
END OutCorrector;

PROCEDURE WrPol( W : WinType; X1, Y1, Z1, X2, Y2, Z2 : LONGREAL);
VAR   S          :UcScreen;
      Dot1G,Dot2G: PlaygroundG;
      Dot1, Dot2 : Playground;
      Color      : INTEGER;
BEGIN S:=W^.UserRecord;
    WITH S^ DO
               Dot1[WestEast]:=X1; Dot1[SouthNort]:=Y1; Dot1[DownUp]:=Z1;
               OutCorrector(S,Dot1);
               Pont(S,Dot1,Dot1G);
               Dot2[WestEast]:=X2; Dot2[SouthNort]:=Y2; Dot2[DownUp]:=Z2;
               OutCorrector(S,Dot2);
               Pont(S,Dot2,Dot2G);
               graphics.setactivepage(Page);
               Color:=(Dot1G[DownUp]+Dot2G[DownUp]) DIV 2;
               graphics.setfillstyle(graphics.SOLID_FILL,Color);
               graphics.bar(Dot1G[WestEast],Dot1G[SouthNort],
                            Dot2G[WestEast],Dot2G[SouthNort]);
               GrKoord(W);
    END  (* WITH *)
END WrPol;

END GrfMeinS.

