
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE Pascal;
IMPORT Kern,WindowS,graphics,TextView,ApView,Processs,
       Menus,GrfMeinS,MsMouse,Str,MuvMul,IO;

TYPE Point=RECORD X:[1..640];
                  Y:[1..350]
           END;
VAR PascalX :ARRAY [0..Kern.MaxFuNumX],[0..Kern.MaxFuNumX] OF Point;
    PascalY :ARRAY [0..Kern.MaxFuNumY] OF Point;
    dX2,dY,posX,posXgeneral,posY:CARDINAL;

VAR  PasWin        : WindowS.WinType;
     k,kx,ky       : CARDINAL;
     X1,X2,Y1,Y2   : CARDINAL;
     Gummi         : BOOLEAN;
PROCEDURE Init;
 BEGIN
 Processs.IniSi:=FALSE; Gummi:=TRUE;
 PasWin:= WindowS.Open(
      WindowS.WinDef(40,0,78,15,               WindowS.Green, WindowS.White,
      FALSE,TRUE,FALSE,TRUE,WindowS.SingleFrame,WindowS.Yellow, WindowS.White));
 X1:=PasWin^.WDef.X1*8;   X2:=PasWin^.WDef.X2*8;
 Y1:=PasWin^.WDef.Y1*14;  Y2:=PasWin^.WDef.Y2*14;
(*WindowS.SetTitle( PasWin,' Pascal triangle ',WindowS.CenterUpperTitle);*)
 WindowS.SetTitle( PasWin,' 㣮쭨 ᪠ ',WindowS.CenterUpperTitle);
 dX2:=((X2-X1) * 2 DIV 5)DIV(Kern.MaxFuNumX+1);
 dY :=((Y2-Y1) * 3 DIV 5)DIV(Kern.MaxFuNumX+1);
 posXgeneral:=X1;  posX:=posXgeneral;
 posY:=Y2-dY;
 FOR k:=0 TO Kern.MaxFuNumX DO
     ky:=Kern.MaxFuNumX-k;
     posY:=posY-dY;
     posXgeneral:=posXgeneral+dX2;
     posX:=posXgeneral;
     FOR kx:=0 TO ky DO
         posX:=posX+2*dX2;
         PascalX[kx,ky].X:=posX;
         PascalX[kx,ky].Y:=posY;
     END
 END;
 dX2:=(X2-X1)DIV(Kern.MaxFuNumY);
 posX:=dX2 DIV 2 + X1;
 posY:=posY-2*dY;
 PascalY[1].X:=posX;  PascalY[1].Y:=posY;
 FOR kx:=2 TO Kern.MaxFuNumY DO
         posX:=posX+dX2;
         PascalY[kx].X:=posX;
         PascalY[kx].Y:=posY;
     END
END Init;

PROCEDURE WrPascal;
VAR   kx,ky   : CARDINAL;
      R       : ARRAY[0..20] OF CHAR;
BEGIN
 graphics.setfillstyle(graphics.SOLID_FILL,1);
 graphics.bar(PasWin^.XA*8-6,PasWin^.YA*14-12,
              PasWin^.XB*8+13,PasWin^.YB*14+21);
 graphics.setcolor(10);
 graphics.settextstyle(2,0,4);
 WindowS.PutOnTop(PasWin);
 FOR ky:=1 TO Kern.MaxFuNumYv DO
  IF Kern.ErrorFy[ky] THEN graphics.setcolor(4) END;
     Str.Concat(R,'',MuvMul.WrFy);  Str.Concat(R,R,Kern.Fy[ky].TxRev2);
     graphics.outtextxy(PascalY[ky].X-20,PascalY[ky].Y-20,R);
     graphics.setcolor(10);
     graphics.circle(PascalY[ky].X,PascalY[ky].Y,2);
 END;
 FOR ky:=0 TO Kern.MaxFuNumXv DO
     FOR kx:=0 TO ky DO
         graphics.circle(PascalX[kx,ky].X,PascalX[kx,ky].Y,2);
     END;
     IF ky*kx#0 THEN
       IF Kern.ErrorFx[ky] THEN graphics.setcolor(4) END;
       Str.Concat(R,'',Kern.Fx[ky].Tx1);
       IF Kern.Fx[ky].Bs#Kern.A1b THEN
         Str.Concat(R,R,MuvMul.WrFx);    Str.Concat(R,R,Kern.Fx[ky].Tx3);
       ELSE(* graphics.outtextxy(PascalX[1,1].X,PascalX[1,1].Y-14,' 1 ');*)
         Str.Concat(R,R,' 1');
       END;
       graphics.outtextxy(PascalX[ky,ky].X,PascalX[ky,ky].Y-14,R);
       graphics.setcolor(10);
     END;
     IF ky=Kern.MaxFuNumXv THEN
       FOR kx:=0 TO ky DO
          graphics.outtextxy(PascalX[kx,ky].X-4,PascalX[kx,ky].Y+14,CHR(48+kx));
       END;
     END
 END;
END WrPascal;

TYPE  TypLine=RECORD Begin,End:Point END;
      TypWay =ARRAY [0..Kern.MaxFuNumX] OF TypLine;
      TypSet =ARRAY Kern.TypFx OF BOOLEAN;
VAR   SetNew, SetOld, SetVeryOld : TypSet;
      WayNew, WayOld, WayVeryOld : TypWay;
      FuNew,  FuOld,  FuVeryOld  : Kern.F;

PROCEDURE WrFuAndWeyAndSet(Fu:Kern.F; Col:CARDINAL;
                            VAR Way:TypWay;  VAR Set:TypSet);
VAR Pascal1,Pascal2:Point;
    k,k1,i :CARDINAL;
    Heat:BOOLEAN;
BEGIN
 Pascal1:=PascalY[Fu.nfY]; Pascal2:=PascalX[0,0];
 graphics.setcolor(Col);
 graphics.line(Pascal1.X,Pascal1.Y,Pascal2.X,Pascal2.Y);
 Way[0].Begin:=Pascal1;     Way[0].End:=Pascal2;
 k1:=0;
 FOR k:=1 TO Kern.MaxFuNumXv DO    Pascal1:=Pascal2;
     Heat:=FALSE;
     FOR i:=1 TO Fu.Sp DO         IF k=Fu.nfX[i] THEN Heat:=TRUE END
     END;
     IF Heat THEN   k1:=k1+1;     Set[k]:=TRUE
     ELSE Set[k]:=FALSE
     END;
     Pascal2:=PascalX[k1,k];
     graphics.line(Pascal1.X,Pascal1.Y,Pascal2.X,Pascal2.Y);
     Way[k].Begin:=Pascal1;     Way[k].End:=Pascal2;
 END;
END WrFuAndWeyAndSet;


PROCEDURE SetToFuAndWey(Set:TypSet; nfY:Kern.TypFy;
                        VAR Fu:Kern.F; VAR Way:TypWay);
VAR k,k1,i : CARDINAL;
    FuOld  : Kern.F;
BEGIN
 FuOld:=Fu;
 Fu.nfY:=nfY; Way[0].Begin:=PascalY[Fu.nfY]; Way[0].End:=PascalX[0,0];
 i:=1;
 FOR k:=0 TO Kern.MaxFuNumXv-1 DO
     k1:=Kern.MaxFuNumXv-k;
     IF Set[k1]=TRUE THEN  Fu.nfX[i]:=k1;
                           INC(i);
     END
 END;
 k1:=0;
 FOR k:=1 TO Kern.MaxFuNumXv DO
     Way[k].Begin:=Way[k-1].End;
     IF Set[k]=TRUE THEN INC(k1)
     END;
     Way[k].End:=PascalX[k1,k];
 END;
 IF i=1 THEN Fu:=FuOld
 ELSE Fu.Sp:=i-1
 END
END SetToFuAndWey;

VAR Actuel: CARDINAL;
PROCEDURE NearUp(B:BOOLEAN):CARDINAL;
 VAR i,n:CARDINAL;
 BEGIN n:=0;
       FOR i:=1 TO Actuel DO
           IF SetNew[i]=B THEN n:=i END
       END;
       RETURN n
END NearUp;

PROCEDURE NearDown(B:BOOLEAN):CARDINAL;
 VAR i,j,n:CARDINAL;
 BEGIN n:=0;
       FOR i:=1 TO Kern.MaxFuNumXv-Actuel DO
           j:=Kern.MaxFuNumXv+1-i;
           IF SetNew[j]=B THEN n:=j END
       END;
       RETURN n
END NearDown;

PROCEDURE Right;
 VAR a,b:CARDINAL;
 BEGIN a:=NearUp(FALSE); b:=NearDown(TRUE);
       IF (a#0) AND (b#0) THEN SetNew[a]:=TRUE; SetNew[b]:=FALSE END;
       IF  (Actuel=Kern.MaxFuNumXv)AND(a#0) THEN SetNew[a]:=TRUE END
END Right;

PROCEDURE Left;
 VAR a,b:CARDINAL;
 BEGIN a:=NearUp(TRUE); b:=NearDown(FALSE);
       IF (a#0) AND (b#0) THEN SetNew[a]:=FALSE; SetNew[b]:=TRUE END;
       IF (Actuel=Kern.MaxFuNumXv)AND(a#0) THEN SetNew[a]:=FALSE END
END Left;

PROCEDURE Select;
VAR Yes             : CHAR;
    nfYnew,k        : CARDINAL;
    Dat             : MsMouse.MsData;
    mp              : MsMouse.MsRange;
    OldPOSwGeneral  : CARDINAL;
BEGIN
 IF NOT Processs.IniSi THEN
        Processs.Si:=Kern.F(TRUE,FALSE,1.E10,1.E10,1.,3,1,Kern.TyStolbX(0.,0.,0.,0.,0.,0.,0.),
           FALSE,Kern.TypnfX(1,1,1,1,1,1,1),1);
        Processs.IniSi:=TRUE;
 END;
 Actuel:=3;
 nfYnew:=Processs.Si.nfY;
 FuNew:= Processs.Si;
 WrPascal;

 WrFuAndWeyAndSet(FuNew,15,WayNew,SetNew);
 WayOld:=WayNew;    WayVeryOld:=WayOld;
 SetOld:=SetNew;    SetVeryOld:=SetOld;
 FuOld :=FuNew;     FuVeryOld :=FuOld;

 IF Menus.IniMous<10 THEN
     mp:=MsMouse.MsRange(630,320,210,2);
     MsMouse.SetRange(mp);
 END;
 IF TextView.POSwGeneral>(17*14+85) THEN
                      TextView.POSwGeneral:=17*14+80
 END;
 OldPOSwGeneral:=TextView.POSwGeneral;
 LOOP
      graphics.setcolor(12);
      IF NOT Gummi THEN graphics.line(WayNew[Actuel].Begin.X,WayNew[Actuel].Begin.Y,
                           WayNew[Actuel].End.X,WayNew[Actuel].End.Y)
      ELSE IF Actuel#0 THEN graphics.circle(WayNew[Actuel].End.X,WayNew[Actuel].End.Y,4)
           ELSE graphics.circle(WayNew[Actuel].Begin.X,WayNew[Actuel].Begin.Y,4)
           END
      END;

      IF Menus.IniMous<10 THEN MsMouse.Cursor(TRUE) END;
      Yes:= Menus.GetKey();
      IF Menus.IniMous<10 THEN  Menus.Pip;
          MsMouse.GetPress(0,Dat); MsMouse.Cursor(FALSE)
      END;

      IF Gummi THEN graphics.setcolor(1);
           IF Actuel#0 THEN graphics.circle(WayNew[Actuel].End.X,WayNew[Actuel].End.Y,4)
           ELSE graphics.circle(WayNew[Actuel].Begin.X,WayNew[Actuel].Begin.Y,4)
           END;
      ELSE graphics.setcolor(15);
           graphics.line(WayNew[Actuel].Begin.X,WayNew[Actuel].Begin.Y,
                         WayNew[Actuel].End.X,  WayNew[Actuel].End.Y);
      END;
      CASE Yes OF
        | 'l':
          IF Actuel#0 THEN
             IF (ABS(INTEGER(WayNew[Actuel].End.Y)-Dat.row)>10) THEN
               IF (WayNew[Actuel].End.Y<CARDINAL(Dat.row)) THEN Yes:=CHR(128+80) END;
               IF (WayNew[Actuel].End.Y>CARDINAL(Dat.row)) THEN Yes:=CHR(128+72) END;
             ELSE
               IF (ABS(INTEGER(WayNew[Actuel].End.X)-Dat.col)>10) THEN
                  IF (WayNew[Actuel].End.X>CARDINAL(Dat.col)) THEN Yes:=CHR(128+75) END;
                  IF (WayNew[Actuel].End.X<CARDINAL(Dat.col)) THEN Yes:=CHR(128+77) END;
               END
             END
          ELSE
             IF (ABS(INTEGER(WayNew[Actuel].Begin.Y)-Dat.row)>10) THEN
               IF (WayNew[Actuel].Begin.Y<CARDINAL(Dat.row)) THEN Yes:=CHR(128+80) END;
               IF (WayNew[Actuel].Begin.Y>CARDINAL(Dat.row)) THEN Yes:=CHR(128+72) END;
             ELSE
               IF (ABS(INTEGER(WayNew[Actuel].Begin.X)-Dat.col)>10) THEN
                  IF (WayNew[Actuel].Begin.X>CARDINAL(Dat.col)) THEN Yes:=CHR(128+75) END;
                  IF (WayNew[Actuel].Begin.X<CARDINAL(Dat.col)) THEN Yes:=CHR(128+77) END;
               END
             END
          END
      END;
      CASE Yes OF
        | CHR(128+75) : IF Actuel=0 THEN
                             IF Processs.Si.nfY>=2 THEN
                                nfYnew:=Processs.Si.nfY-1
                             END
                        ELSE
                          IF FuNew.Sp>1 THEN
                             IF NOT Gummi THEN SetNew[Actuel]:=FALSE
                             ELSE Left
                             END
                          END
                        END;
        | CHR(128+77) : IF Actuel=0 THEN
                             IF Processs.Si.nfY<Kern.MaxFuNumYv THEN
                                nfYnew:=Processs.Si.nfY+1
                             END
                        ELSE IF NOT Gummi THEN SetNew[Actuel]:=TRUE
                             ELSE Right
                             END
                        END;
        | CHR(128+80) : IF Actuel<Kern.MaxFuNumXv THEN Actuel:=Actuel+1 END;
        | CHR(128+72) : IF Actuel>=1 THEN Actuel:=Actuel-1 END;
        | CHR(27),'r' : WindowS.Hide(PasWin);
                        IF Menus.IniMous<10 THEN
                            mp:=MsMouse.MsRange(630,10,345,1);
                            MsMouse.SetRange(mp);
                        END;
                        EXIT;
        | CHR(13):
           IF Gummi THEN
                Gummi:=FALSE;
                graphics.setcolor(1);
                IF Actuel#0 THEN graphics.circle(WayNew[Actuel].End.X,WayNew[Actuel].End.Y,4)
                ELSE graphics.circle(WayNew[Actuel].Begin.X,WayNew[Actuel].Begin.Y,4)
                END
           ELSE Gummi:=TRUE;
                graphics.setcolor(15);
                graphics.line(WayNew[Actuel].Begin.X,WayNew[Actuel].Begin.Y,
                               WayNew[Actuel].End.X,WayNew[Actuel].End.Y)
           END;
           FOR k:=1 TO MuvMul.MaxPointNum DO
                GrfMeinS.WrCircle(ApView.GrWin,MuvMul.Xold^[k],MuvMul.Yold^[k],14.);
           END;
      END;  (*Menus.Pip;*)
      CASE Yes OF
        | CHR(128+75), CHR(128+77):
           SetToFuAndWey(SetNew,nfYnew,FuNew,WayNew);
           FOR k:=0 TO Kern.MaxFuNumXv DO
             IF WayNew[k] # WayOld[k] THEN
                graphics.setcolor(1);
                graphics.line(WayVeryOld[k].Begin.X,WayVeryOld[k].Begin.Y,
                              WayVeryOld[k].End.X,  WayVeryOld[k].End.Y);
                IF Gummi THEN graphics.circle(WayOld[k].End.X,WayOld[k].End.Y,4)
                END;
                graphics.setcolor(0);
                graphics.line(WayOld[k].Begin.X,WayOld[k].Begin.Y,
                              WayOld[k].End.X,  WayOld[k].End.Y);
                graphics.setcolor(15);
                graphics.line(WayNew[k].Begin.X,WayNew[k].Begin.Y,
                              WayNew[k].End.X,  WayNew[k].End.Y);
             ELSE IF WayVeryOld[k] # WayOld[k] THEN
                     graphics.setcolor(1);
                     graphics.line(WayVeryOld[k].Begin.X,WayVeryOld[k].Begin.Y,
                                   WayVeryOld[k].End.X,  WayVeryOld[k].End.Y)
                  END
             END
           END;

           TextView.POSwGeneral:=OldPOSwGeneral;
           graphics.setfillstyle(graphics.SOLID_FILL,1);
           graphics.bar(20,TextView.POSwGeneral,625,TextView.POSwGeneral+24);

           Kern.SetUpFu(FuNew);     Processs.Si:=FuNew;
           IF NOT FuVeryOld.Error   THEN ApView.GrFu(FuVeryOld,1) END;
           IF NOT FuOld.Error       THEN ApView.GrFu(FuOld,0)     END;
           IF NOT FuNew.Error       THEN ApView.GrFu(FuNew,15);
                graphics.setcolor(15);
                TextView.Wr(FuNew);
           ELSE graphics.setcolor(15);
                graphics.outtextxy(100,TextView.POSwGeneral,'bad function');
           END;
           WayVeryOld:=WayOld;       WayOld:=WayNew;
           SetVeryOld:=SetOld;       SetOld:=SetNew;
           FuVeryOld :=FuOld;        FuOld :=FuNew;
      END;
 END
END Select;
END Pascal.
