
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE  ApView;
IMPORT GrfMeinS,Kern,TextView,Menus,graphics,MATHLIB,Str,
       (* for ReadPoint *)File, MuvMul;

PROCEDURE GrFu(Fu:Kern.F;Col:CARDINAL);
  CONST N = 100;
 VAR X,Y,dX      :LONGREAL;
      I           :INTEGER;
      Bul,Line,Yes:BOOLEAN;
BEGIN
 Line := FALSE;
 dX:=(Kern.MaxX-Kern.MinX)/LONGREAL(N);  X:=(*Kern.MinX*)x1+dX/10.;
 IF (Fu.Co AND (MuvMul.XYty IN Fu.Mode)) OR
    (NOT Fu.Co AND (MuvMul.XYty IN MuvMul.Mode)) THEN
       WHILE X< Kern.MaxX DO X:=X+dX;
         IF Kern.Fu(Fu,X,Y) THEN
            IF (x1<Y) AND (Y<x2) THEN                   (* x <---> y *)
              IF NOT Line THEN GrfMeinS.WrPoint(ApView.GrWin,Y,X,4.) END;
                                                        (* X <---> Y *)
              GrfMeinS.WrLineCol(ApView.GrWin,Y,X,Col); (* X <---> Y *)
              Line:=TRUE
            ELSE Line := FALSE
            END
         ELSE Line := FALSE
         END
       END
 ELSE
       WHILE X<x2(*Kern.MaxX*) DO X:=X+dX;
         IF Kern.Fu(Fu,X,Y) THEN
            IF (y1<Y) AND (Y<y2) THEN
              IF NOT Line THEN GrfMeinS.WrPoint(ApView.GrWin,X,Y,4.) END;
              GrfMeinS.WrLineCol(ApView.GrWin,X,Y,Col);
              Line:=TRUE
            ELSE Line := FALSE
            END
         ELSE Line := FALSE
         END
       END
 END
END GrFu;

PROCEDURE Picture(Pag:CARDINAL);
 VAR n,i   : CARDINAL;
     R   :ARRAY[0..100] OF CHAR;
 BEGIN
   IF (MuvMul.XYty IN MuvMul.Mode) THEN ApView.Modif(Kern.MinY,Kern.MinX,Kern.MaxY,Kern.MaxX);
                               ELSE ApView.Modif(Kern.MinX,Kern.MinY,Kern.MaxX,Kern.MaxY);
   END;
   GrWin:=GrWin1;  (* Page 0 *)
   IF Pag=1 THEN
    GrWin:=GrWin2; (* Page 1 *)
    graphics.setactivepage(1);
   END;
   GrfMeinS.GrKoord(GrWin);
   IF Pag=1 THEN
       graphics.setfillstyle(graphics.SOLID_FILL,1);
       graphics.bar(307,332,425,343);   graphics.bar(430,332,540,343);
       graphics.bar(545,332,635,343);
       Str.Concat(R,CHR(26)+CHR(24)+CHR(25)+CHR(27),
       " -move; '-,+'-step size control; 'ENTER'-point; 'DEL'-delete; 'ESC'-exit");
       graphics.settextstyle(0,0,1); graphics.setcolor(15);
       graphics.outtextxy(20,335,R);
       graphics.settextstyle(2,0,4);
   END;
   IF (MuvMul.XYty IN MuvMul.Mode) THEN
         FOR n:=1 TO MuvMul.MaxPointNum DO
           GrfMeinS.WrCircle(ApView.GrWin,MuvMul.Yold^[n],MuvMul.Xold^[n],14.);
         END
   ELSE  FOR n:=1 TO MuvMul.MaxPointNum DO
           GrfMeinS.WrCircle(ApView.GrWin,MuvMul.Xold^[n],MuvMul.Yold^[n],14.);
         END
   END
END Picture;

PROCEDURE OpenPicture1page;
 VAR i   : CARDINAL;
BEGIN
    GrWin:=GrWin2; (* Page 1 *)
    graphics.setactivepage(1);
    graphics.setcolor(11);
    graphics.setfillstyle(graphics.SOLID_FILL,1);
    graphics.bar(40,20,320,200);
    graphics.setvisualpage(1);
    FOR i:=1 TO 20 DO
       graphics.bar(305+15*i, 5,       320+15*i, 210+4*i);
       graphics.line(320+15*i,5,       320+15*i, 210+4*i);
       graphics.bar(10,       195+4*i, 320+15*i, 210+4*i);
       graphics.line(10,      210+4*i, 320+15*i, 210+4*i);
    END
END OpenPicture1page;

PROCEDURE ClosePicture1page;
 VAR i,ii : CARDINAL;
 BEGIN
    graphics.setcolor(11);
    graphics.setfillstyle(graphics.SOLID_FILL,0);
    FOR ii:=0 TO 20 DO i:=20-ii;
       graphics.bar( 340+10*i,1,      440+10*i,350);
       graphics.line(340+10*i,5,      340+10*i,212+5*i);
       graphics.bar( 1,       212+5*i,640,     250+5*i);
       graphics.line(10,       212+5*i,340+10*i,212+5*i);
    END;
    graphics.setactivepage(0);
END ClosePicture1page;

PROCEDURE Modif(X1,Y1, X2,Y2 : LONGREAL);
 VAR n1:INTEGER;
     r1,Xtest,Ytest,dX,dY:LONGREAL;
 BEGIN
    IF ABS(X1-X2)<1.E-100 THEN X2:=X1+1. END;
    dX:=(X2-X1)/5.;
    x1:=X1-dX;                             x2:=X2+dX;
    n1:=INTEGER(MATHLIB.Log10(x2-x1))-1;   r1:=MATHLIB.Pow(10.,LONGREAL(n1));
    x2:=LONGREAL(INTEGER(x2/r1)+1)*r1;     x1:=LONGREAL(INTEGER(x1/r1)-1)*r1;
    dX:=(x2-x1)/5.;
    IF (x1<0.)AND(0.<x2) THEN Xtest:=x1;
       WHILE Xtest<0. DO Xtest:=Xtest+dX END;
       IF Xtest<dX-Xtest THEN  x1:=x1-Xtest;    x2:=x2-Xtest
       ELSE                    x1:=x1-Xtest+dX; x2:=x2-Xtest+dX
       END
    END;
    GrfMeinS.SetBorderX(GrWin1,x1,x2);     GrfMeinS.SetBorderX(GrWin2,x1,x2);
    dY:=(Y2-Y1)/5.;
    y1:=Y1-dY;                     y2:=Y2+dY;
    IF y1#y2 THEN n1:=INTEGER(MATHLIB.Log10(y2-y1))-1
    ELSE n1:=1 END;
    r1:=MATHLIB.Pow(10.,LONGREAL(n1));
    y2:=LONGREAL(INTEGER(y2/r1)+1)*r1;     y1:=LONGREAL(INTEGER(y1/r1)-1)*r1;
    dY:=(y2-y1)/5.;
    IF (y1<0.)AND(0.<y2) THEN Ytest:=y1;
       WHILE Ytest<0. DO Ytest:=Ytest+dY END;
       IF Ytest<dY-Ytest THEN  y1:=y1-Ytest;    y2:=y2-Ytest
       ELSE                    y1:=y1-Ytest+dY; y2:=y2-Ytest+dY
       END
    END;
    GrfMeinS.SetBorderY(GrWin1,y1,y2);     GrfMeinS.SetBorderY(GrWin2,y1,y2);
END Modif;

PROCEDURE ReadPoint():BOOLEAN;
  VAR   x,y,xPost,dx,dy,QrestSizeX,QrestSizeY : LONGREAL;
        DelNum,i             : CARDINAL;
        RdP                  : CHAR;
        OK                   : BOOLEAN;
  TYPE  tyR  = ARRAY[0..50] OF CHAR;
  CONST coR  = tyR('Points number is limited in demonstration:   N < ');
  TYPE  tyR1 = ARRAY[0..70] OF CHAR;
  VAR   marc : ARRAY [0..11] OF CHAR;
        R    : tyR1;
  BEGIN
            GrfMeinS.RdPoint(ApView.GrWin2,x,y,RdP);
            IF (MuvMul.XYty IN MuvMul.Mode) THEN xPost:=y; y:=x; x:=xPost  END;
            IF RdP='T' THEN
  (*12*)         IF MuvMul.MaxPointNum< 12(*MuvMul.MaxArray*) THEN
                 INC(MuvMul.MaxPointNum);
                 MuvMul.Xold^[MuvMul.MaxPointNum]:=x; MuvMul.Yold^[MuvMul.MaxPointNum]:=y;
                 MuvMul.X^[MuvMul.MaxPointNum]:=MuvMul.Xold^[MuvMul.MaxPointNum]*MuvMul.Kc-MuvMul.Ka;
                 MuvMul.Y^[MuvMul.MaxPointNum]:=MuvMul.Yold^[MuvMul.MaxPointNum]*MuvMul.Kd-MuvMul.Kb;
                 MuvMul.QuestionSave:=TRUE;
                 GrfMeinS.WrCircle(ApView.GrWin,x,y,14.);
                 Kern.ToRecalculation;
              ELSE
 (*12*)          Str.IntToStr( 12(*LONGINT(MuvMul.MaxPointNum)*),marc,10,OK);
                 IF OK THEN Str.Concat(R,coR,marc) END;
                 graphics.settextstyle(0,0,1);
                 graphics.setcolor(12); graphics.outtextxy(20,317,R);
                 graphics.settextstyle(2,0,4);
              END
            ELSE  IF RdP='D' THEN
                     graphics.setfillstyle(graphics.SOLID_FILL,0);
                     graphics.bar(20,317,430,331);
                     DelNum:=0;
                     QrestSizeX:=(ApView.x2-ApView.x1)/640.*5.;
                     QrestSizeY:=(ApView.y2-ApView.y1)/350.*5.;
                     FOR i:=1 TO MuvMul.MaxPointNum DO
                       dx:=x-MuvMul.Xold^[i]; dy:=y-MuvMul.Yold^[i];
                       IF (dx*dx < QrestSizeX*QrestSizeX) AND
                          (dy*dy < QrestSizeY*QrestSizeY) THEN
                          DelNum:=i
                       END
                     END;
                     IF DelNum>0 THEN
                         DEC(MuvMul.MaxPointNum);
                         FOR i:=DelNum TO MuvMul.MaxPointNum DO
                           MuvMul.Xold^[i]:=MuvMul.Xold^[i+1];
                           MuvMul.Yold^[i]:=MuvMul.Yold^[i+1];
                           MuvMul.X^[i]:=MuvMul.X^[i+1];
                           MuvMul.Y^[i]:=MuvMul.Y^[i+1];
                         END;
                         MuvMul.QuestionSave:=TRUE;  Kern.ToRecalculation;
                     END
                  ELSE  RETURN TRUE
                  END
            END;
            RETURN FALSE
END ReadPoint;

PROCEDURE Init;
 BEGIN
 GrWin1:= WindowS.Open(WindowS.WinDef(0,0,40,15,WindowS.Green,WindowS.Blue,
      FALSE,TRUE,FALSE,FALSE,WindowS.SingleFrame,WindowS.LightCyan, WindowS.Black));
 GrfMeinS.Open(GrWin1);
 GrfMeinS.SetKoordAxis( GrWin1,GrfMeinS.Frame);
 GrfMeinS.SetBorderX(GrWin1,  -100.,    100.);
 GrfMeinS.SetBorderY(GrWin1,  -100.,    100.);
 GrfMeinS.SetBorderZ(GrWin1,  0.,    15.);
 GrfMeinS.SetBegKor( GrWin1,  0.,     0.,    5. );
 GrfMeinS.SetPage(GrWin1,0);
 GrWin2:= WindowS.Open( WindowS.WinDef(0,0,79,21, WindowS.Green, WindowS.Blue,
      FALSE,TRUE,FALSE,FALSE,WindowS.SingleFrame,WindowS.LightCyan, WindowS.Black));
 GrfMeinS.Open(GrWin2);
 GrfMeinS.SetKoordAxis( GrWin2,GrfMeinS.Frame);
 GrfMeinS.SetBorderX(GrWin2,  -100.,    100.);
 GrfMeinS.SetBorderY(GrWin2,  -100.,    100.);
 GrfMeinS.SetBorderZ(GrWin2,  0.,    15.);
 GrfMeinS.SetBegKor( GrWin2,  0.,     0.,    5. );
 GrfMeinS.SetPage(GrWin2,1);
 GrWin:=GrWin1
END Init;

END ApView.
