
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE Exampl;
IMPORT Menus,MuvMul,Processs,File,FIO,Str,Kern,TextView;

TYPE TypName=ARRAY [1..15]OF CHAR;
     AAA    = ARRAY [1..62] OF INTEGER;
CONST  AAAc =  AAA( 1210, 1211, 1212,1213,1214,  1221,1222,1231,1232,
               7510,7520,7530,
               7611,7612,   7621,7622,7623,    7630,7640,7650,7660,
               7661,7662,7663,7664,7665,7666,7667,7668,7669,7670,7671,7672,
               7710,7720,  7731,7732,7733,7734,7735,   7740,7750,7760,7770,
               7810,7820,7830,   7910,7920,7930,
               8111,8112,8113,8114,8115,8116, 8124,8125,8126,8127,8128,8129);
PROCEDURE An(N:INTEGER);
VAR  An1,An2,An3   : ARRAY[0..36] OF CHAR;
BEGIN
  An1:=' x - ⥬ [C] (ࠤ. )';
  CASE N OF
   | 8111..8129,
     1210..1232,
     7710..7739,
     7760..7770: An2:=' y - ⥯஢ [/( )]    ';
   | 7740..7750: An2:=' y - ⥯஢ [ /( )]  ';
   | 7810..7890: An2:=' y - ⥯  [ /( )]    ';
   | 7910:       An2:=' y - ᪠ 離 [  ]';
   | 7920:       An2:=' y - ᪠ 離 [  ]';
   | 7930:       An2:=' y - ᪠ 離 [  ]';
   | 7610..7629: An2:=' y - 㤥쭮 ᮯ⨢ [ ]';
   | 7630..7660: An2:=' y -㤥쭮 ᮯ⨢ [ ]';
   | 7661..7672: An2:=' y - 㤥쭠 ⥯ [/  ]';
   | 7510..7590: An2:=' y - ⭮          [  / ^3 ]';
  END;
  CASE N OF
   | 7710,7810,7910,7510,7720,7920,7520:
                 An3:='  奥 .. 奥 .., .1973  ';
   | 7611..7623: An3:=' .., ࣨ, 1973, . 142';
                 An1:=' x - ⥬ [K] (ࠤ.좨)';
   | 7820:       An3:='  㪠 .. 娧, .1963';
   | 7731..7770,7830,7930,7530:
                 An3:='.ࠢ.,࣮,1957';
   | 7630..7660: An3:=' .., ࣨ,1985,. 4.83';
                 An1:=' x - ⥬ [K] (ࠤ.좨)';
   | 7661..7672: An3:=' .., ࣨ,1985,. 4.94';
                 An1:=' x - ⥬ [K] (ࠤ.좨)';
   | 8111..8116: An3:=' .., ࣨ,1985,. 4.75';
                 An1:=' x - ⥬ [K] (ࠤ.좨)';
   | 8124..8129,
     1210..1299: An3:=' .., ࣨ,1985,. 4.67';
                 An1:=' x - ⥬ [K] (ࠤ.좨)';
  END;
            Menus.WrStrAnounse(FALSE,An1);
            Menus.WrStrAnounse(FALSE,An2);
            Menus.WrStrAnounse(TRUE,An3);
END An;

PROCEDURE Pr1(N:INTEGER);
VAR OK,Found       : BOOLEAN;
    FilName        : TypName;
    F              : FIO.File;
    Ent            : FIO.DirEntry;
    R              : ARRAY[0..100] OF CHAR;
    Num,I1,I2,I2max : CARDINAL;
    X,Y:LONGREAL;
BEGIN
    Str.Copy(FilName,'approx.lib');
    FOR I1:=1 TO 62 DO
      IF AAAc[I1]=N THEN Num:=I1
      END
    END;
    Found:=FIO.ReadFirstEntry(FilName,FIO.FileAttr(FIO.system),Ent);
    IF NOT Found THEN
            Menus.WrStrAnounse(FALSE,'     ᢮⢠ -');
            Menus.WrStrAnounse(FALSE,' : approx.lib    ᪥');
            Menus.WrStrAnounse(TRUE,'  Simple formula  ');
    ELSE
            MuvMul.MaxPointNum:=0;
            MuvMul.Ka:=0.; MuvMul.Kb:=0.;
            MuvMul.Kc:=1.; MuvMul.Kd:=1.;
            MuvMul.Mode:=MuvMul.TypMode{};
            MuvMul.WrF:= MuvMul.WrConst;
            MuvMul.WrFx:= MuvMul.WrF[MuvMul.x];
            MuvMul.WrFy:= MuvMul.WrF[MuvMul.y];

        F:=FIO.Open(FilName);
        FOR I1:=1 TO Num-1 DO
            I2max:=FIO.RdInt(F);
            FOR I2:=1 TO I2max DO
              X:=FIO.RdLngReal(F); Y:=FIO.RdLngReal(F);
            END
        END;
            MuvMul.MaxPointNum:=0;
            I2max:=FIO.RdInt(F);
            IF I2max>MuvMul.MaxArray THEN I2max:=MuvMul.MaxArray END;
            FOR I2:=1 TO I2max DO
              INC(MuvMul.MaxPointNum);
              MuvMul.X^[MuvMul.MaxPointNum]:=FIO.RdLngReal(F);
              MuvMul.Y^[MuvMul.MaxPointNum]:=FIO.RdLngReal(F);
              MuvMul.Xold^[MuvMul.MaxPointNum]:=MuvMul.X^[MuvMul.MaxPointNum];
              MuvMul.Yold^[MuvMul.MaxPointNum]:=MuvMul.Y^[MuvMul.MaxPointNum];
            END;
            FIO.Close(F);
            Kern.ToRecalculation;
            TextView.PutOnTop(TextView.WinFuDelt,1);
            Processs.TopSpis:=3;
            Processs.ProcessI(Processs.TopSpis,0,TRUE);
            An(N);
       (*   Menus.CommandESC(Men2);    *)
            MuvMul.QuestionSave:=FALSE;
   END
END Pr1;

END Exampl.
