
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE Koff;
IMPORT Kern,WindowS,graphics,TextView,Processs,
       Menus,MsMouse,Str,IO, ApView,MATHLIB;

PROCEDURE SetUpKoff;
VAR i    : CARDINAL;
    D,D1 : LONGREAL;
BEGIN
   Processs.SiKoff:=Processs.Si;
   D1:=MATHLIB.Sqrt(Processs.SiKoff.Delta2);
   FOR i:=1 TO Processs.SiKoff.Sp DO
      Processs.SiKoff:=Processs.Si;
      Processs.SiKoff.M[i]:=Processs.SiKoff.M[i]*1.0001;
      Kern.SetUpFuDelt(Processs.SiKoff);
      D:=MATHLIB.Sqrt(Processs.SiKoff.Delta2);
      TextView.Ustoich[i] :=(D-D1)/D1*10000.;
   END;
   Processs.SiKoff:=Processs.Si;
END SetUpKoff;

VAR Win:WindowS.WinType;
PROCEDURE Chang;
 VAR Yes : CHAR;
     Num : CARDINAL;
     Kof,OldKof : LONGREAL;
 BEGIN
 Num:=1;
 WindowS.Use(Menus.Anounse); WindowS.GotoXY(0,0);
 IF Processs.IniSi THEN
      WindowS.SetTitle( TextView.WinFuDelt,
        '..⪫. .⪫.Y'+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
        '㥬 㭪'+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
        '⮩稢 -',WindowS.LeftUpperTitle);
      TextView.PutOnTop(TextView.WinFuDelt,1);
      Menus.WrStrAnounse( FALSE,'   ५ 롥 -  ');
      Menus.WrStrAnounse( FALSE,' ।஢  "Enter" ');
      Menus.WrStrAnounse( FALSE,'⬥ .."U", 室  "Esc" ');
      Processs.IniSiKoff:=TRUE;
      SetUpKoff;
      LOOP
          TextView.WrInKoff(Processs.SiKoff,Num);
          Yes:= Menus.GetKey();
          CASE Yes OF
            | CHR(128+75),CHR(128+72) : IF Num>1 THEN  Num:=Num-1
                                        ELSE Num:=Processs.SiKoff.Sp
                                        END;
            | CHR(128+77),CHR(128+80) : IF Num< Processs.SiKoff.Sp THEN  Num:=Num+1
                                        ELSE Num:=1
                                        END;
            | CHR(27) :
                WindowS.SetTitle( TextView.WinFuDelt,
                   '㥬 㭪樨' +CHR(196)+CHR(196)+CHR(196)
                   +CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)
                   +CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)
                   +CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+CHR(196)+
                   '..'+CHR(196)+CHR(196)+'.⪫.',WindowS.RightUpperTitle);
                    TextView.PutOnTop(TextView.WinFuDelt,1);
                    Processs.Process(Processs.OldProcess,Processs.TopSpis,0,FALSE);
                    EXIT;
            | CHR(85),CHR(117):
                 ApView.GrFu(Processs.SiKoff,1);
                 Kof:=OldKof;  Processs.SiKoff.M[Num]:=Kof;
                 Kern.SetUpFuDelt(Processs.SiKoff);
                 ApView.GrFu(Processs.SiKoff,11);
            | CHR(13) :
                 Menus.WrIntAnounse( FALSE,'  樥 - No.',Num);
                 Menus.WrStrAnounse( FALSE,'                                    ');
                 Menus.WrStrAnounse( FALSE,'                                    ');
                 WindowS.Use(Win); WindowS.GotoXY(1,0);
                 OldKof:=Processs.SiKoff.M[Num];
                 Kof:=IO.RdLngReal();
                 ApView.GrFu(Processs.SiKoff,1);
                 Processs.SiKoff.M[Num]:=Kof;
                 ApView.GrFu(Processs.SiKoff,11);
                 Kern.SetUpFuDelt(Processs.SiKoff);
                 WindowS.Hide(Win);
                 Menus.WrStrAnounse( FALSE,'   ५ 롥 -  ');
                 Menus.WrStrAnounse( FALSE,' ।஢  "Enter" ');
                 Menus.WrStrAnounse( FALSE,'⬥ .."U", 室  "Esc" ');
           END; (* case *)
      END; (* loop *)


 ELSE Menus.WrStrAnounse( FALSE,'     砫 롥 㭪       ');
      Menus.WrStrAnounse( FALSE,'    "- ᪠"      ');
      Menus.WrStrAnounse( TRUE,'     "᪠   ᪠"     ');
 END;
 WindowS.Hide(Menus.Anounse);
END Chang;
BEGIN
 Win:= WindowS.Open(WindowS.WinDef(41,13,72,15,WindowS.LightGray, WindowS.Black,
      FALSE,TRUE,TRUE,TRUE,WindowS.SingleFrame,WindowS.LightGray, WindowS.Black));
 WindowS.SetTitle( Win,'  樥',WindowS.CenterUpperTitle);
END Koff.
