
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE Poi;
IMPORT Storage,WindowS,IO;

CONST MaxArray   = 201;
TYPE  PointsTyp  = POINTER TO RECORD
                                MaxPointNum : [0..MaxArray];
                                X,Y         : ARRAY [1..MaxArray] OF LONGREAL;
                              END;
PROCEDURE Open( P:PointsTyp );
 BEGIN  Storage.ALLOCATE(P,SIZE(PointsTyp));
        P^.MaxPointNum:=0
END Open;


VAR AktualPointNum : [1..MaxArray+1];
PROCEDURE OutPoint(P:PointsTyp;VAR Xa,Ya:LONGREAL):BOOLEAN;
BEGIN
 WITH P^ DO
    IF AktualPointNum<=MaxPointNum THEN
           Xa:=X[AktualPointNum];  Ya:=Y[AktualPointNum];
           INC(AktualPointNum);
           RETURN TRUE
    ELSE   RETURN FALSE
    END
 END
END OutPoint;

PROCEDURE NulOutPoint(P:PointsTyp);
 BEGIN AktualPointNum :=1
END NulOutPoint;

PROCEDURE GrfEdit( P:PointsTyp );
 BEGIN
END GrfEdit;

PROCEDURE Save( P:PointsTyp );
 BEGIN
END Save;

PROCEDURE Load( P:PointsTyp );
 BEGIN
END Load;

PROCEDURE Copy( D,R:PointsTyp );
 BEGIN D^:=R^
END Copy;

PROCEDURE InPutPointTxt(P:PointsTyp; Xa,Ya:LONGREAL):BOOLEAN;
BEGIN
 WITH P^ DO
    IF MaxPointNum< MaxArray THEN
           INC(MaxPointNum);
           X[MaxPointNum]:=Xa;   Y[MaxPointNum]:=Ya;
           RETURN TRUE
    ELSE   RETURN FALSE
    END
 END
END InPutPointTxt;

VAR WinTextEdit          : WindowS.WinType;     (* dubl in MuvMul.mod *)
PROCEDURE TextEdit( P:PointsTyp );              (* Demo --> Commerc   *)
VAR Yes:BOOLEAN;                                (*   12 --> MaxArray  *)
    Xa,Ya:LONGREAL;
BEGIN
 LOOP
   IF (P^.MaxPointNum > 12 (*MaxArray*) ) OR (NOT Yes) THEN EXIT END;
   IO.WrLn; IO.WrStr('X='); Xa:=IO.RdLngReal();
   IF WindowS.Fortuna THEN
     IO.WrStr('Y='); Ya:=IO.RdLngReal();
     IF WindowS.Fortuna THEN
          Yes:=InPutPointTxt(P,Xa,Ya)
     ELSE Yes:=FALSE
     END
   ELSE   Yes:=FALSE
   END;
   WindowS.Hide(WinTextEdit);
 END; (* loop *)

 IF P^.MaxPointNum>12  (*MaxArray*) THEN
   IO.WrStr('    In this version (demonstration)  ');
   IO.WrStr(' the point number are restricted to  ');
   IO.WrStr('            N < '); IO.WrInt(12 (*MaxArray*),3);
 END
END TextEdit;

PROCEDURE Init;
BEGIN
 WinTextEdit:= WindowS.Open(WindowS.WinDef(41,1,78,15,WindowS.LightGray, WindowS.Black,
      FALSE,TRUE,TRUE,TRUE,WindowS.SingleFrame,WindowS.LightGray, WindowS.Black));
 WindowS.SetTitle( WinTextEdit,'Points Edit',WindowS.CenterUpperTitle);
END Init;
END Poi.
