
(* Simple formula (C) Sidyganov 1993 *)

IMPLEMENTATION MODULE Processs;
IMPORT graphics, ApView, TextView, Menus, Str, Collect,IO,MuvMul,
       WindowS,BiosIO,MATHLIB;
FROM MuvMul IMPORT MaxPointNum;

VAR GrFu:ApView.GrFuType;

VAR N,M,Fill         : CARDINAL;
    xt,xT,yT,xTi,yTi,xTim,yTim:CARDINAL;
PROCEDURE ViewTime(Stran,m,n:CARDINAL);
 VAR i : CARDINAL;
     Num:ARRAY [0..15] OF CHAR;
     OK : BOOLEAN;
 BEGIN IF n=0 THEN
          IF Stran=0 THEN (*xT:=54*8-5; yT:=14*14+5;*)
                          xT:=46*8-8; yT:=2;
          ELSE            xT:=65*8-10; yT:=22*14+6;
          END;
          xt:=xT; graphics.setcolor(14); Fill:=8;
          xTim:=xT+m*5; yTim:=yT+9; yTi:=yTim;
          graphics.setfillstyle(graphics.SOLID_FILL,7);
          graphics.bar(xT-16,yT-1,xTim+28,yTim+1);
          graphics.setfillstyle(graphics.SOLID_FILL,3);
          graphics.bar(xT,yT,xTim,yTim);
          M:=m; N:=0;
          Str.CardToStr(LONGCARD(MaxPointNum),Num,10,OK);
          Str.Concat(Num,'points = ',Num);
          graphics.outtextxy(xt+20,yT-1,Num);
          graphics.setcolor(0);
          graphics.outtextxy(xT-14,yT,'0%');
          graphics.outtextxy(xTim+2,yT,'100%');
       ELSE
          graphics.setfillstyle(graphics.SOLID_FILL,Fill);
          FOR i:=N+1 TO n DO
             xTi:=xT+5; graphics.bar(xT,yT,xTi,yTi); xT:=xTi;
          END;
          N:=n;
          IF n=m THEN  graphics.setcolor(14);
                       graphics.outtextxy(xt+35,yT-1,'Ready');
                       graphics.outtextxy(xt+35,yT-1,'Ready');
                       IF Stran=0 THEN Collect.ColMin(492,167) END;
                       Menus.Horse
          END;
       END;
END ViewTime;

PROCEDURE ProcessJ(j:Kern.TypFx;Str:CARDINAL;Calc:BOOLEAN);
 BEGIN TopSpis:=j; OldProcess:=J;
  IF Calc THEN  ViewTime(Str,20,0);
                IF Kern.ToSum THEN Kern.Sum END;
                ViewTime(Str,20,7)
  END;
  ApView.Picture(Str);
  IF Str=0 THEN graphics.settextstyle(2,0,4);
                TextView.Clear(TextView.WinFuDelt,1);
  END;
  IF Calc AND Kern.Sp[j].Error THEN  Kern.InitSp(j); ViewTime(Str,20,8) END;

  IF NOT Kern.Sp[j].Error THEN GrFu(Kern.Sp[j],14);
     IF Str=0 THEN Wr(Kern.Sp[j])
     END;
  END;
  IF (Kern.Sp[j] # Kern.Sm[j]) THEN GrFu(Kern.Sm[j],10);

     IF Str=0 THEN Wr(Kern.Sm[j]) END;
  END;
  IF Calc THEN ViewTime(Str,20,15) END;
  IF Str=0 THEN TextView.WrABCD END;
  IF IniSi THEN Kern.SetUpFu(Si);   GrFu(Si,15);
     IF Str=0 THEN Wr(Si) END;
  END;
  IF IniSiKoff THEN  GrFu(SiKoff,11);
     IF Str=0 THEN Wr(SiKoff) END;
  END;

  IF Calc THEN ViewTime(Str,20,20) END;
END ProcessJ;

TYPE TyPaletta = ARRAY [1..10] OF CARDINAL;
CONST Paletta  = TyPaletta(14,13,12,10,2,5,11,3,7,9);

PROCEDURE Process7(Str:CARDINAL;Calc:BOOLEAN);
 VAR n:CARDINAL;
 BEGIN n:=0;
  IF Calc THEN  ViewTime(Str,20,0);
                IF Kern.ToSum THEN Kern.Sum END;
                ViewTime(Str,20,7) END;
  ApView.Picture(Str);
  IF Str=0 THEN graphics.settextstyle(2,0,4);
                TextView.Clear(TextView.WinFuDelt,1);
  END;

  IF Calc AND Kern.Sp[1].Error THEN  Kern.InitSp(1);ViewTime(Str,20,8) END;
  IF Kern.Sp[1].Delta2<1.E-20 THEN INC(n);
     GrFu(Kern.Sp[1],  Paletta[n]);
     IF Str=0 THEN Wr(Kern.Sp[1]) END;
     IF Calc AND Kern.Sp[2].Error THEN Kern.InitSp(2);
        ViewTime(Str,20,10) END;
     IF Kern.Sp[2].nfY=1 THEN INC(n);
        GrFu(Kern.Sp[2],  Paletta[n]);
        IF Str=0 THEN Wr(Kern.Sp[2]) END;
     END
  ELSE
     IF Calc AND Kern.Sp[2].Error THEN  Kern.InitSp(2);
        ViewTime(Str,20,10) END;
     IF Kern.Sp[2].Delta2<1.E-20 THEN INC(n);
        GrFu(Kern.Sp[2],  Paletta[n]);
        IF Str=0 THEN Wr(Kern.Sp[2]) END;
     ELSE
        IF Kern.Sp[1].nfX[1] # 1 THEN INC(n); GrFu(Kern.Sp[1],Paletta[n]);
                             IF Str=0 THEN Wr(Kern.Sp[1]) END;
        END;

        IF (Kern.Sp[1] # Kern.Sm[1]) AND (Kern.Sm[1].nfX[1] # 1) THEN INC(n);
            GrFu(Kern.Sm[1],  Paletta[n]);
            IF Str=0 THEN Wr(Kern.Sm[1]) END
        END;

        IF NOT Kern.Sp[2].VeryBig THEN INC(n);
           GrFu(Kern.Sp[2],  Paletta[n]);
           IF Str=0 THEN Wr(Kern.Sp[2]) END;
        END;

        IF (Kern.Sp[2] # Kern.Sm[2]) THEN INC(n);
            GrFu(Kern.Sm[2],  Paletta[n]);
            IF Str=0 THEN Wr(Kern.Sm[2]) END
        END;

        IF Calc AND Kern.Sp[3].Error THEN  Kern.InitSp(3);
           ViewTime(Str,20,14) END;
        IF NOT Kern.Sp[3].VeryBig THEN INC(n);
           GrFu(Kern.Sp[3],  Paletta[n]);
           IF Str=0 THEN Wr(Kern.Sp[3]) END;
        END;

       IF Str=0 THEN TextView.WrABCD END;
       IF ((n<=8) AND (NOT IniSi)) OR (n<=6) THEN
          IF (Kern.Sp[3] # Kern.Sm[3]) AND (NOT Kern.Sp[3].VeryBig) THEN INC(n);
              GrFu(Kern.Sm[3],  Paletta[n]);
              IF Str=0 THEN Wr(Kern.Sm[3]) END
          END;
        END;

      END (* Sp2.Del2=0 *)
  END; (* Sp1.Del2=0 *)

  IF IniSi THEN Kern.SetUpFu(Si);  GrFu(Si,15);
      IF Str=0 THEN Wr(Si) END
  END;
  IF IniSiKoff THEN  GrFu(SiKoff,11);
     IF Str=0 THEN Wr(SiKoff) END;
  END;

  IF Calc THEN  ViewTime(Str,20,20) END;
END Process7;

PROCEDURE ProcessI(j:Kern.TypFx;Str:CARDINAL;Calc:BOOLEAN);
 VAR  n : CARDINAL;
 BEGIN
  TopSpis:=j; OldProcess:=I;
  IF j<=3 THEN Process7(Str,Calc)
  ELSE n:=0;
       IF Calc THEN  ViewTime(Str,20,0);
                     IF Kern.ToSum THEN Kern.Sum END;
                     ViewTime(Str,20,7) END;
       ApView.Picture(Str);
       IF Str=0 THEN graphics.settextstyle(2,0,4);
                     TextView.Clear(TextView.WinFuDelt,1);
       END;

       IF Calc AND Kern.Sp[j].Error THEN Kern.InitSp(j);
          ViewTime(Str,20,12) END;
       INC(n);GrFu(Kern.Sp[j],Paletta[n]);
       IF Str=0 THEN Wr(Kern.Sp[j]) END;
       IF (Kern.Sp[j] # Kern.Sm[j]) THEN
         INC(n); GrFu(Kern.Sm[j],Paletta[n]);
         IF Str=0 THEN Wr(Kern.Sm[j]) END
       END;

       IF Calc AND Kern.Sp[j-1].Error THEN Kern.InitSp(j-1);
          ViewTime(Str,20,16) END;
       INC(n); GrFu(Kern.Sp[j-1],Paletta[n]);

       IF Str=0 THEN Wr(Kern.Sp[j-1]) END;
       IF (Kern.Sp[j-1] # Kern.Sm[j-1]) THEN
         INC(n); GrFu(Kern.Sm[j-1],Paletta[n]);
         IF Str=0 THEN Wr(Kern.Sm[j-1]) END
       END;

       IF Str=0 THEN TextView.WrABCD END;
       IF IniSi THEN Kern.SetUpFu(Si);
           INC(n); GrFu(Si,15);
           IF Str=0 THEN Wr(Si) END
       END;
      IF IniSiKoff THEN  GrFu(SiKoff,11);
         IF Str=0 THEN Wr(SiKoff) END;
      END;
       IF Calc THEN ViewTime(Str,20,20) END
  END;
END ProcessI;

PROCEDURE Process7K(Str:CARDINAL;Calc:BOOLEAN);
 VAR n:CARDINAL;
 BEGIN n:=0;
  IF Calc THEN  ViewTime(Str,20,0);
                IF Kern.ToSum THEN Kern.Sum END;
                ViewTime(Str,20,7) END;
  ApView.Picture(Str);
  IF Str=0 THEN graphics.settextstyle(2,0,4);
                TextView.Clear(TextView.WinFuDelt,1);
  END;

  IF Calc AND Kern.Sp[1].Error THEN  Kern.InitSp(1);
     ViewTime(Str,20,8) END;
  IF Kern.Sp[1].Delta2<1.E-20 THEN INC(n);
     GrFu(Kern.Sp[1],  Paletta[n]);
     IF Str=0 THEN Wr(Kern.Sp[1]) END;
     IF Calc AND Kern.Sp[2].Error THEN  Kern.InitSp(2);
        ViewTime(Str,20,10) END;
     IF Kern.Sp[2].nfY=1 THEN INC(n);
        GrFu(Kern.Sp[2],  Paletta[n]);
        IF Str=0 THEN Wr(Kern.Sp[2]) END;
     END
  ELSE
     IF Calc AND Kern.Sp[2].Error THEN  Kern.InitSp(2);
        ViewTime(Str,20,10) END;
     IF Kern.Sp[2].Delta2<1.E-20 THEN INC(n);
        GrFu(Kern.Sp[2],  Paletta[n]);
        IF Str=0 THEN Wr(Kern.Sp[2]) END;
     ELSE
        IF Kern.Sp[1].nfX[1] # 1 THEN INC(n); GrFu(Kern.Sp[1],Paletta[n]);
                             IF Str=0 THEN Wr(Kern.Sp[1]) END;
        END;

        IF (Kern.Sp[1] # Kern.Sm[1]) AND (Kern.Sm[1].nfX[1] # 1) THEN INC(n);
            GrFu(Kern.Sm[1],  Paletta[n]);
            IF Str=0 THEN Wr(Kern.Sm[1]) END
        END;

        IF NOT Kern.Sp[2].VeryBig THEN INC(n);
           GrFu(Kern.Sp[2],  Paletta[n]);
           IF Str=0 THEN Wr(Kern.Sp[2]) END;
        END;

        IF (Kern.Sp[2] # Kern.Sm[2]) THEN INC(n);
            GrFu(Kern.Sm[2],  Paletta[n]);
            IF Str=0 THEN Wr(Kern.Sm[2]) END
        END;

        IF Calc AND Kern.Sp[3].Error THEN  Kern.InitSp(3);
           ViewTime(Str,20,14) END;
        IF NOT Kern.Sp[3].VeryBig THEN INC(n);
           GrFu(Kern.Sp[3],  Paletta[n]);
           IF Str=0 THEN Wr(Kern.Sp[3]) END;
        END;

        IF ((n<=8) AND (NOT IniSi)) OR (n<=6) THEN
          IF (Kern.Sp[3] # Kern.Sm[3]) AND (NOT Kern.Sp[3].VeryBig) THEN INC(n);
              GrFu(Kern.Sm[3],  Paletta[n]);
              IF Str=0 THEN Wr(Kern.Sm[3]) END
          END;
        END;

        IF Str=0 THEN TextView.WrABCD; INC(n) END;
        IF ((n<=8) AND (NOT IniSi)) OR (n<=6) THEN INC(n);
           IF Calc AND Kern.Sp[4].Error THEN  Kern.InitSp(4);
              ViewTime(Str,20,19) END;
           IF NOT Kern.Sp[4].VeryBig THEN INC(n);
              GrFu(Kern.Sp[4],  Paletta[n]);
              IF Str=0 THEN Wr(Kern.Sp[4]) END;
           END;
        END;

        IF ( ((n<=8)AND(NOT IniSi)) OR (n<=6))
                     AND (Kern.Sp[2] # Kern.Sm[2])
                     AND (NOT Kern.Sm[4].VeryBig)  THEN INC(n);
              GrFu(Kern.Sm[4], Paletta[n]);
              IF Str=0 THEN Wr(Kern.Sp[4]) END;
        END;

      END (* Sp2.Del2=0 *)
  END; (* Sp1.Del2=0 *)

  IF IniSi THEN Kern.SetUpFu(Si);
      GrFu(Si,15);
      IF Str=0 THEN Wr(Si) END
  END;

      IF IniSiKoff THEN  GrFu(SiKoff,11);
         IF Str=0 THEN Wr(SiKoff) END;
      END;
  IF Calc THEN  ViewTime(Str,20,20) END
END Process7K;

 (*  ProcessK  > ProcessI  *)
 (*  ProcessI - 2 function  *)
 (*  ProcessK - 3-4 function  *)

PROCEDURE ProcessK(j:Kern.TypFx;Str:CARDINAL;Calc:BOOLEAN);
 VAR  n : CARDINAL;
 BEGIN
  TopSpis:=j; OldProcess:=K;
  IF j<=3 THEN Process7K(Str,Calc)
  ELSE n:=0;
       IF Calc THEN  ViewTime(Str,20,0);
                     IF Kern.ToSum THEN Kern.Sum END;
                     ViewTime(Str,20,7) END;
       ApView.Picture(Str);
       IF Str=0 THEN graphics.settextstyle(2,0,4);
                     TextView.Clear(TextView.WinFuDelt,1);
       END;

       IF Calc AND Kern.Sp[j].Error THEN Kern.InitSp(j);
          ViewTime(Str,20,12) END;
       INC(n);GrFu(Kern.Sp[j],Paletta[n]);
       IF Str=0 THEN Wr(Kern.Sp[j]) END;
       IF (Kern.Sp[j] # Kern.Sm[j]) THEN
         INC(n); GrFu(Kern.Sm[j],Paletta[n]);
         IF Str=0 THEN Wr(Kern.Sm[j]) END
       END;

       IF Calc AND Kern.Sp[j-1].Error THEN Kern.InitSp(j-1);
          ViewTime(Str,20,16) END;
       INC(n); GrFu(Kern.Sp[j-1],Paletta[n]);
       IF Str=0 THEN Wr(Kern.Sp[j-1]) END;
       IF (Kern.Sp[j-1] # Kern.Sm[j-1]) THEN
         INC(n); GrFu(Kern.Sm[j-1],Paletta[n]);
         IF Str=0 THEN Wr(Kern.Sm[j-1]) END
       END;

      IF Str=0 THEN TextView.WrABCD END;
      IF ((TextView.POSwGeneral<=318) AND (NOT IniSi))
              OR (TextView.POSwGeneral<=298) THEN INC(n);
          IF Calc AND Kern.Sp[j-2].Error THEN Kern.InitSp(j-2);
             ViewTime(Str,20,18) END;
          INC(n);  GrFu(Kern.Sp[j-2],Paletta[n]);
          IF Str=0 THEN Wr(Kern.Sp[j-2]) END;
       END;

       IF ((TextView.POSwGeneral<=318) AND (NOT IniSi))
              OR (TextView.POSwGeneral<=298) THEN INC(n);
          IF (Kern.Sp[j-2] # Kern.Sm[j-2]) THEN
            INC(n); GrFu(Kern.Sm[j-2],Paletta[n]);
            IF Str=0 THEN Wr(Kern.Sm[j-2]) END
          END
       END;

       IF IniSi THEN Kern.SetUpFu(Si);
           INC(n); GrFu(Si,15);
           IF Str=0 THEN Wr(Si) END
       END;
       IF IniSiKoff THEN  GrFu(SiKoff,11);
         IF Str=0 THEN Wr(SiKoff) END;
       END;
       IF Calc THEN ViewTime(Str,20,20) END
  END
END ProcessK;
PROCEDURE Process(n:TypOldProcess;j:Kern.TypFx;Str:CARDINAL;Calc:BOOLEAN);
 BEGIN
  CASE n OF
   |J: ProcessJ(j,Str,Calc);
   |I: ProcessI(j,Str,Calc);
   |K: ProcessK(j,Str,Calc);
  END;
END Process;

VAR X           : LONGREAL;
    marc        : ARRAY [0..21] OF CHAR;
    OK          : BOOLEAN;
    POSwGeneral : INTEGER;
    Yes         : CHAR;
PROCEDURE ProcGrFu(Fu:Kern.F;Col:CARDINAL);
 VAR Y         :LONGREAL;
 BEGIN
    IF Kern.Fu(Fu,X,Y) THEN
       Str.RealToStr(Y,15,TRUE,marc,OK);
       ApView.GrFu(Fu,Col);
       graphics.outtextxy(475,POSwGeneral,marc);
       POSwGeneral:=POSwGeneral+10;
    END
END ProcGrFu;

VAR  ProcWin        : WindowS.WinType;
PROCEDURE FuTest(n:TypOldProcess;j:Kern.TypFx);
 BEGIN
   WindowS.Use(Menus.Anounse); WindowS.GotoXY(0,0);
   IF (MuvMul.XYty IN MuvMul.Mode) THEN
    (*   Menus.WrIntAnounse( FALSE,'Enter Y-coordinate of the point No.',MaxPointNum);*)
       Menus.WrStrAnounse( FALSE,' न Y                ');
       Menus.WrStrAnounse( FALSE,'                                    ');
       Menus.WrStrAnounse( FALSE,'                                    ');
       WindowS.Use(MuvMul.WinY);
       IO.WrStr('Y=');
   ELSE
    (*   Menus.WrIntAnounse( FALSE,'Enter X-coordinate of the point No.',MaxPointNum);*)
       Menus.WrStrAnounse( FALSE,' न X                ');
       Menus.WrStrAnounse( FALSE,'                                    ');
       Menus.WrStrAnounse( FALSE,'                                    ');
       WindowS.Use(MuvMul.WinX);
       IO.WrStr('X=');
   END;
  X:=IO.RdLngReal();
  ViewTime(0,20,0);
  Str.RealToStr(X,13,TRUE,marc,OK);
  WindowS.Hide(Menus.Anounse); WindowS.Hide(MuvMul.WinX);  WindowS.Hide(MuvMul.WinY);
  Str.Concat(marc,marc,CHR(32));
  Str.Concat(marc,CHR(32),marc);
  WindowS.SetTitle( ProcWin,marc,WindowS.CenterUpperTitle);
  graphics.setfillstyle(graphics.SOLID_FILL,1);
  graphics.bar(ProcWin^.XA*8-6, ProcWin^.YA*14-12,
               ProcWin^.XB*8+13,ProcWin^.YB*14+21);
  ViewTime(0,20,10);
  WindowS.PutOnTop(ProcWin);
  POSwGeneral :=140;
  GrFu:=ProcGrFu;
  CASE n OF
   |J: ProcessJ(j,0,FALSE);
   |I: ProcessI(j,0,FALSE);
   |K: ProcessK(j,0,FALSE);
  END;
  GrFu:=ApView.GrFu;
  ViewTime(3,20,20);
  Yes:= Menus.GetKey();
  WindowS.Hide(ProcWin);

END FuTest;

PROCEDURE ProcessA();
VAR Kb :LONGREAL;
    Ka :LONGREAL;
    OK,Exit   :BOOLEAN;
    j         :CARDINAL;

   PROCEDURE A;
     BEGIN
      Kern.ToRecalcMuv;   Kern.Sum;
      FOR j:=1 TO 7 DO    Kern.InitSp(j);
                          GrFu(Kern.Sp[j],j+8);
      END; (* j *)
      IF BiosIO.KeyPressed() THEN Exit:=TRUE END;
   END A;
   PROCEDURE B():BOOLEAN;
    BEGIN
      MuvMul.InitBasis; A;
      OK:=MuvMul.MuvXavt(Kern.MinX);  A;
      IF Exit THEN RETURN FALSE END;
      OK:=MuvMul.MuvXavt(Kern.MinYx); A;
      OK:=MuvMul.MuvXavt(Kern.MaxX);  A;
      IF Exit THEN RETURN FALSE END;
      OK:=MuvMul.MuvXavt(Kern.MaxYx); A;
      Ka:=Kern.MinX-(Kern.MaxX-Kern.MinX)/50.;
      OK:=MuvMul.MuvXavt(Ka);         A;
      Ka:=Kern.MaxX+(Kern.MaxX-Kern.MinX)/50.;
      OK:=MuvMul.MuvXavt(Kb);         A;
      RETURN TRUE;
   END B;
BEGIN
  Exit := FALSE;
  ApView.OpenPicture1page;
  ApView.Picture(1);
  OK:=B();
  MuvMul.InitBasis;
  OK:=MuvMul.MuvYavt(Kern.MinXy);  A;
  OK:=MuvMul.MuvYavt(Kern.MinY);   A;
  OK:=MuvMul.MuvYavt(Kern.MaxXy);  A;
  OK:=MuvMul.MuvYavt(Kern.MaxY);   A;
  Kb:=Kern.MinY-(Kern.MaxY-Kern.MinY)/50.;
  OK:=MuvMul.MuvXavt(Kb);          A;
  Kb:=Kern.MaxY+(Kern.MaxY-Kern.MinY)/50.;
  OK:=MuvMul.MuvYavt(Kb);          A;
  MuvMul.InitBasis;
  OK:=MuvMul.MuvYavt(Kern.MinXy);  OK:=B();
   IF NOT Exit THEN  OK:=MuvMul.MuvYavt(Kern.MinY); OK:=B() END;
   IF NOT Exit THEN  OK:=MuvMul.MuvYavt(Kern.MaxXy);OK:=B() END;
   IF NOT Exit THEN  OK:=MuvMul.MuvYavt(Kern.MaxY); OK:=B() END;
   IF NOT Exit THEN  Kb:=Kern.MinY-(Kern.MaxY-Kern.MinY)/50.;
                     OK:=MuvMul.MuvXavt(Kb);        OK:=B() END;
   IF NOT Exit THEN  Kb:=Kern.MaxY+(Kern.MaxY-Kern.MinY)/50.;
                     OK:=MuvMul.MuvYavt(Kb);        OK:=B() END;


  ApView.ClosePicture1page;
  graphics.setvisualpage(0); graphics.setactivepage(0);
  MuvMul.InitBasis;
  Collect.Rezjume;
  Kern.ToRecalcMuv; Kern.Sum;
  Processs.ProcessI(3,0,TRUE)
END ProcessA;

VAR    R    : LONGREAL;
PROCEDURE ProcessB();
VAR DeltKb, Kb, CentrKb:LONGREAL;
    DeltKa, Ka, CentrKa:LONGREAL;
    j        :CARDINAL;
    OK,Exit  :BOOLEAN;
    Rr    : LONGREAL;
BEGIN
  ApView.OpenPicture1page;
  ApView.Picture(1);
  DeltKa:=ApView.x2-ApView.x1;            DeltKb:=ApView.y2-ApView.y1;
  CentrKa:=(ApView.x2+ApView.x1)/2.;      CentrKa:=(ApView.y2+ApView.y1)/2.;
  MuvMul.InitBasis;
  Kern.ToRecalcMuv;   Kern.Sum;
  FOR j:=1 TO 7 DO       Kern.InitSp(j);
                         GrFu(Kern.Sp[j],j+8);
  END; (* j *)
  LOOP
     R:=MATHLIB.Sqrt(R); Rr:=LONGREAL(INTEGER(R)); R:=(R-Rr)*10.;
     Ka:=CentrKa+DeltKa*(1.-R/10.);
     R:=MATHLIB.Sqrt(R); Rr:=LONGREAL(INTEGER(R)); R:=(R-Rr)*10.;
     Kb:=CentrKb+DeltKb*(1.-R/10.);

       MuvMul.InitBasis;
       OK:=MuvMul.MuvXavt(Ka);
       Kern.ToRecalcMuv;   Kern.Sum;
       FOR j:=1 TO 7 DO    Kern.InitSp(j);
                           GrFu(Kern.Sp[j],j+8);
       END; (* j *)
       IF BiosIO.KeyPressed() THEN EXIT END;

       OK:=MuvMul.MuvYavt(Kb);
       Kern.ToRecalcMuv;   Kern.Sum;
       FOR j:=1 TO 7 DO    Kern.InitSp(j);
                           GrFu(Kern.Sp[j],j+8);
       END; (* j *)
       IF BiosIO.KeyPressed() THEN EXIT END;

       OK:=MuvMul.RecoverX();
       Kern.ToRecalcMuv;   Kern.Sum;
       FOR j:=1 TO 7 DO    Kern.InitSp(j);
                           GrFu(Kern.Sp[j],j+8);
       END; (* j *)
       IF BiosIO.KeyPressed() THEN EXIT END;
  END;   (* loop *)
  ApView.ClosePicture1page;
  graphics.setvisualpage(0); graphics.setactivepage(0);
  MuvMul.InitBasis;
  Collect.Rezjume;
  Kern.ToRecalcMuv; Kern.Sum;
  Processs.ProcessI(3,0,TRUE)
END ProcessB;

PROCEDURE Init;
BEGIN
 R:=3.142398567321;
 GrFu:=ApView.GrFu;
 Processs.IniSiKoff:=FALSE;
 ProcWin:= WindowS.Open(
      WindowS.WinDef(55,9,79,15,               WindowS.LightCyan, WindowS.White,
      FALSE,TRUE,FALSE,TRUE,WindowS.SingleFrame,WindowS.LightGreen, WindowS.White));
END Init;
END Processs.
